"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionStartInitiated = exports.SessionEventArgs = exports.SettingsTapPackage = exports.RepositorySettingsPackageDefinition = exports.RepositoryPackageDefinition = exports.RepositoryPackageReference = exports.ProfileGroup = exports.ListItemType = exports.ComponentSettings = exports.FileDescriptor = exports.Resource = exports.PluginTypeSelectorControl = exports.PictureControl = exports.PasswordControl = exports.MultiSelectControl = exports.DropdownControl = exports.EnabledControl = exports.DirectoryPathControl = exports.FilePathControl = exports.ComboBoxControl = exports.TextBoxControl = exports.DataGridControl = exports.DataGridReferenceControl = exports.CheckBoxControl = exports.AvailableValue = exports.ButtonsControl = exports.ButtonControl = exports.ExternalParameter = exports.MetaData = exports.DisplayAttribute = exports.VisualStatus = exports.UnitAttribute = exports.Icon = exports.ColumnDisplayName = exports.LayoutMode = exports.Layout = exports.Setting = exports.ComponentSettingsListItem = exports.AnnotatedObject = exports.ComponentSettingsList = exports.DisplayMode = exports.ComponentSettingsIdentifier = exports.ComponentSettingsBase = exports.Links = exports.Session = exports.ImageResolveErrorResponse = exports.NoResponderError = exports.ErrorResponse = exports.PackageSpecifier = exports.Image = void 0;
exports.TestPlanExecutionStateChangedEventArgs = exports.TestPlanChangeEventArgs = exports.StoppedEventArgs = exports.StoppingEventArgs = exports.StartedEventArgs = exports.StartingEventArgs = exports.SessionTimeoutEventArgs = exports.SessionEventType = exports.SessionEvent = exports.MetricValue = exports.MetricsConfiguration = exports.SessionMetricInfo = exports.MetricsPollRate = exports.SessionMetricType = exports.SessionMetricKind = exports.ResultColumn = exports.Result = exports.LogEvent = exports.TestStepRun = exports.TestRun = exports.WatchDog = exports.Parameter = exports.BreakPoints = exports.InstalledFile = exports.Interaction = exports.CommonContext = exports.CommonSettings = exports.ValidationError = exports.TestStepValidationError = exports.TestStepCopy = exports.TestStepType = exports.TestStep = exports.TestPlan = exports.ExecutionState = exports.Verdict = exports.RunStatus = exports.MissingLicenseResponse = exports.LogEntry = exports.LogList = exports.ApiException = exports.ImageCreationFailed = exports.ImageCreated = exports.ImageCreating = exports.ImageEventArgs = exports.SessionInactivityLimitHit = exports.SessionShutdownFailed = exports.SessionShutdown = exports.SessionShutdownInitiated = exports.SessionStartFailed = exports.SessionStarted = void 0;
exports.AssetUpdatedEvent = exports.MetadataUpdatedEvent = exports.RunnerDeletedEvent = exports.RunnerUpdatedEvent = exports.RunnerRegisteredEvent = exports.RunnerEvent = exports.TestPlanRunCompletedEventArgs = exports.TestPlanRunStartEventArgs = exports.TestPlanRunEvent = exports.TestStepRunCompletedEventArgs = exports.TestStepRunStartEventArgs = exports.TestStepRunEvent = exports.OnTestStepRun = exports.OnTestPlanRun = exports.MetricsConfigurationChangedEventArgs = exports.HeartbeatEventArgs = exports.TestPlanSettingsChangedEventArgs = exports.UserInputRequestCompletedEventArgs = exports.UserInputRequestEventArgs = exports.BreakEventArgs = exports.TestStepChangeEventArgs = exports.SettingsChangedEventArgs = void 0;
var Image = /** @class */ (function () {
    function Image(data) {
        this.packages = [];
        this.repositories = [];
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Image.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            if (Array.isArray(_data['Packages'])) {
                this.packages = [];
                for (var _i = 0, _a = _data['Packages']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.packages.push(PackageSpecifier.fromJS(item));
                }
            }
            if (Array.isArray(_data['Repositories'])) {
                this.repositories = [];
                for (var _b = 0, _c = _data['Repositories']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.repositories.push(item);
                }
            }
            this.id = _data['Id'];
        }
    };
    Image.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Image();
        result.init(data);
        return result;
    };
    Image.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        if (Array.isArray(this.packages)) {
            data['Packages'] = [];
            for (var _i = 0, _a = this.packages; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Packages'].push(item.toJSON());
            }
        }
        if (Array.isArray(this.repositories)) {
            data['Repositories'] = [];
            for (var _b = 0, _c = this.repositories; _b < _c.length; _b++) {
                var item = _c[_b];
                data['Repositories'].push(item);
            }
        }
        data['Id'] = this.id;
        return data;
    };
    return Image;
}());
exports.Image = Image;
var PackageSpecifier = /** @class */ (function () {
    function PackageSpecifier(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    PackageSpecifier.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.version = _data['Version'];
            this.architecture = _data['Architecture'];
            this.oS = _data['OS'];
        }
    };
    PackageSpecifier.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new PackageSpecifier();
        result.init(data);
        return result;
    };
    PackageSpecifier.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['Version'] = this.version;
        data['Architecture'] = this.architecture;
        data['OS'] = this.oS;
        return data;
    };
    return PackageSpecifier;
}());
exports.PackageSpecifier = PackageSpecifier;
var ErrorResponse = /** @class */ (function () {
    function ErrorResponse(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ErrorResponse.prototype.init = function (_data) {
        if (_data) {
            this.type = _data['Type'];
            this.message = _data['Message'];
            this.parameter = _data['Parameter'];
            this.source = _data['Source'];
            this.stackTrace = _data['StackTrace'];
            this.inner = _data['Inner'] ? ErrorResponse.fromJS(_data['Inner']) : undefined;
        }
    };
    ErrorResponse.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ErrorResponse();
        result.init(data);
        return result;
    };
    ErrorResponse.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Type'] = this.type;
        data['Message'] = this.message;
        data['Parameter'] = this.parameter;
        data['Source'] = this.source;
        data['StackTrace'] = this.stackTrace;
        data['Inner'] = this.inner ? this.inner.toJSON() : undefined;
        return data;
    };
    return ErrorResponse;
}());
exports.ErrorResponse = ErrorResponse;
var NoResponderError = /** @class */ (function (_super) {
    __extends(NoResponderError, _super);
    function NoResponderError() {
        return _super.call(this, { message: 'No responders.' }) || this;
    }
    NoResponderError.fromJS = function () {
        return new NoResponderError();
    };
    return NoResponderError;
}(ErrorResponse));
exports.NoResponderError = NoResponderError;
var ImageResolveErrorResponse = /** @class */ (function (_super) {
    __extends(ImageResolveErrorResponse, _super);
    function ImageResolveErrorResponse(data) {
        return _super.call(this, data) || this;
    }
    ImageResolveErrorResponse.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.dotGraph = _data['DotGraph'];
        }
    };
    ImageResolveErrorResponse.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ImageResolveErrorResponse();
        result.init(data);
        return result;
    };
    ImageResolveErrorResponse.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['DotGraph'] = this.dotGraph;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ImageResolveErrorResponse;
}(ErrorResponse));
exports.ImageResolveErrorResponse = ImageResolveErrorResponse;
var Session = /** @class */ (function () {
    function Session(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Session.prototype.init = function (_data) {
        if (_data) {
            this.subject = _data['Subject'];
            this.id = _data['Id'];
            this.imageId = _data['ImageId'];
            this.executionState = _data['ExecutionState'];
            this.testPlanRunId = _data['TestPlanRunId'];
            this.startedBy = _data['StartedBy'];
            this.metadata = _data['Metadata'];
        }
    };
    Session.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Session();
        result.init(data);
        return result;
    };
    Session.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Subject'] = this.subject;
        data['Id'] = this.id;
        data['ImageId'] = this.imageId;
        data['ExecutionState'] = this.executionState;
        data['TestPlanRunId'] = this.testPlanRunId;
        data['StartedBy'] = this.startedBy;
        data['Metadata'] = this.metadata;
        return data;
    };
    return Session;
}());
exports.Session = Session;
var Links = /** @class */ (function () {
    function Links(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Links.prototype.init = function (_data) {
        if (_data) {
            this.editor = _data['Editor'];
        }
    };
    Links.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Links();
        result.init(data);
        return result;
    };
    Links.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Editor'] = this.editor;
        return data;
    };
    return Links;
}());
exports.Links = Links;
var ComponentSettingsBase = /** @class */ (function () {
    function ComponentSettingsBase(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'ComponentSettingsBase';
    }
    ComponentSettingsBase.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.groupName = _data['GroupName'];
        }
    };
    ComponentSettingsBase.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['ComponentSettingsType'] === 'ComponentSettingsIdentifier') {
            var result = new ComponentSettingsIdentifier();
            result.init(data);
            return result;
        }
        if (data['ComponentSettingsType'] === 'ComponentSettingsList') {
            var result = new ComponentSettingsList();
            result.init(data);
            return result;
        }
        if (data['ComponentSettingsType'] === 'ComponentSettings') {
            var result = new ComponentSettings();
            result.init(data);
            return result;
        }
        throw new Error("The abstract class 'ComponentSettingsBase' cannot be instantiated.");
    };
    ComponentSettingsBase.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['ComponentSettingsType'] = this._discriminator;
        data['Name'] = this.name;
        data['GroupName'] = this.groupName;
        return data;
    };
    return ComponentSettingsBase;
}());
exports.ComponentSettingsBase = ComponentSettingsBase;
var ComponentSettingsIdentifier = /** @class */ (function (_super) {
    __extends(ComponentSettingsIdentifier, _super);
    function ComponentSettingsIdentifier(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ComponentSettingsIdentifier';
        return _this;
    }
    ComponentSettingsIdentifier.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    ComponentSettingsIdentifier.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ComponentSettingsIdentifier();
        result.init(data);
        return result;
    };
    ComponentSettingsIdentifier.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ComponentSettingsIdentifier;
}(ComponentSettingsBase));
exports.ComponentSettingsIdentifier = ComponentSettingsIdentifier;
/** The supported layout modes. */
var DisplayMode;
(function (DisplayMode) {
    DisplayMode["MasterDetail"] = "MasterDetail";
    DisplayMode["DataGrid"] = "DataGrid";
})(DisplayMode = exports.DisplayMode || (exports.DisplayMode = {}));
var ComponentSettingsList = /** @class */ (function (_super) {
    __extends(ComponentSettingsList, _super);
    function ComponentSettingsList(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ComponentSettingsList';
        return _this;
    }
    ComponentSettingsList.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Items'])) {
                this.items = [];
                for (var _i = 0, _a = _data['Items']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.items.push(ComponentSettingsListItem.fromJS(item));
                }
            }
            this.displayMode = _data['DisplayMode'];
            this.itemType = _data['ItemType'];
            this.itemTypeDisplayName = _data['ItemTypeDisplayName'];
        }
    };
    ComponentSettingsList.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ComponentSettingsList();
        result.init(data);
        return result;
    };
    ComponentSettingsList.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data['Items'] = [];
            for (var _i = 0, _a = this.items; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Items'].push(item.toJSON());
            }
        }
        data['DisplayMode'] = this.displayMode;
        data['ItemType'] = this.itemType;
        data['ItemTypeDisplayName'] = this.itemTypeDisplayName;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ComponentSettingsList;
}(ComponentSettingsBase));
exports.ComponentSettingsList = ComponentSettingsList;
var AnnotatedObject = /** @class */ (function () {
    function AnnotatedObject(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    AnnotatedObject.prototype.init = function (_data) {
        if (_data) {
            this.visualStatus = _data['VisualStatus'] ? VisualStatus.fromJS(_data['VisualStatus']) : undefined;
            this.valueType = _data['ValueType'];
            this.display = _data['Display'] ? DisplayAttribute.fromJS(_data['Display']) : undefined;
            this.metaData = _data['MetaData'] ? MetaData.fromJS(_data['MetaData']) : undefined;
            this.externalParameter = _data['ExternalParameter'] ? ExternalParameter.fromJS(_data['ExternalParameter']) : undefined;
            this.unitAttribute = _data['UnitAttribute'] ? UnitAttribute.fromJS(_data['UnitAttribute']) : undefined;
        }
    };
    AnnotatedObject.fromJS = function (data) {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        data = typeof data === 'object' ? data : {};
        throw new Error("The abstract class 'AnnotatedObject' cannot be instantiated.");
    };
    AnnotatedObject.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['VisualStatus'] = this.visualStatus ? this.visualStatus.toJSON() : undefined;
        data['ValueType'] = this.valueType;
        data['Display'] = this.display ? this.display.toJSON() : undefined;
        data['MetaData'] = this.metaData ? this.metaData.toJSON() : undefined;
        data['ExternalParameter'] = this.externalParameter ? this.externalParameter.toJSON() : undefined;
        data['UnitAttribute'] = this.unitAttribute ? this.unitAttribute.toJSON() : undefined;
        return data;
    };
    return AnnotatedObject;
}());
exports.AnnotatedObject = AnnotatedObject;
var ComponentSettingsListItem = /** @class */ (function (_super) {
    __extends(ComponentSettingsListItem, _super);
    function ComponentSettingsListItem(data) {
        return _super.call(this, data) || this;
    }
    ComponentSettingsListItem.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Settings'])) {
                this.settings = [];
                for (var _i = 0, _a = _data['Settings']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.settings.push(Setting.fromJS(item));
                }
            }
            this.name = _data['Name'];
            this.enabledResource = _data['EnabledResource'];
        }
    };
    ComponentSettingsListItem.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ComponentSettingsListItem();
        result.init(data);
        return result;
    };
    ComponentSettingsListItem.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.settings)) {
            data['Settings'] = [];
            for (var _i = 0, _a = this.settings; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Settings'].push(item.toJSON());
            }
        }
        data['Name'] = this.name;
        data['EnabledResource'] = this.enabledResource;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ComponentSettingsListItem;
}(AnnotatedObject));
exports.ComponentSettingsListItem = ComponentSettingsListItem;
var Setting = /** @class */ (function (_super) {
    __extends(Setting, _super);
    function Setting(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'Setting';
        return _this;
    }
    Setting.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Errors'])) {
                this.errors = [];
                for (var _i = 0, _a = _data['Errors']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.errors.push(item);
                }
            }
            this.layout = _data['Layout'] ? Layout.fromJS(_data['Layout']) : undefined;
            this.columnDisplayName = _data['ColumnDisplayName'] ? ColumnDisplayName.fromJS(_data['ColumnDisplayName']) : undefined;
            this.valueDescription = _data['ValueDescription'];
            this.propertyName = _data['PropertyName'];
            this.submit = _data['Submit'];
            if (Array.isArray(_data['Icons'])) {
                this.icons = [];
                for (var _b = 0, _c = _data['Icons']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.icons.push(Icon.fromJS(item));
                }
            }
        }
    };
    Setting.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['ControlType'] === 'ButtonControl') {
            var result_1 = new ButtonControl();
            result_1.init(data);
            return result_1;
        }
        if (data['ControlType'] === 'ButtonsControl') {
            var result_2 = new ButtonsControl();
            result_2.init(data);
            return result_2;
        }
        if (data['ControlType'] === 'CheckBoxControl') {
            var result_3 = new CheckBoxControl();
            result_3.init(data);
            return result_3;
        }
        if (data['ControlType'] === 'DataGridReferenceControl') {
            var result_4 = new DataGridReferenceControl();
            result_4.init(data);
            return result_4;
        }
        if (data['ControlType'] === 'DataGridControl') {
            var result_5 = new DataGridControl();
            result_5.init(data);
            return result_5;
        }
        if (data['ControlType'] === 'TextBoxControl') {
            var result_6 = new TextBoxControl();
            result_6.init(data);
            return result_6;
        }
        if (data['ControlType'] === 'ComboBoxControl') {
            var result_7 = new ComboBoxControl();
            result_7.init(data);
            return result_7;
        }
        if (data['ControlType'] === 'FilePathControl') {
            var result_8 = new FilePathControl();
            result_8.init(data);
            return result_8;
        }
        if (data['ControlType'] === 'DirectoryPathControl') {
            var result_9 = new DirectoryPathControl();
            result_9.init(data);
            return result_9;
        }
        if (data['ControlType'] === 'EnabledControl') {
            var result_10 = new EnabledControl();
            result_10.init(data);
            return result_10;
        }
        if (data['ControlType'] === 'DropdownControl') {
            var result_11 = new DropdownControl();
            result_11.init(data);
            return result_11;
        }
        if (data['ControlType'] === 'MultiSelectControl') {
            var result_12 = new MultiSelectControl();
            result_12.init(data);
            return result_12;
        }
        if (data['ControlType'] === 'PasswordControl') {
            var result_13 = new PasswordControl();
            result_13.init(data);
            return result_13;
        }
        if (data['ControlType'] === 'PictureControl') {
            var result_14 = new PictureControl();
            result_14.init(data);
            return result_14;
        }
        if (data['ControlType'] === 'PluginTypeSelectorControl') {
            var result_15 = new PluginTypeSelectorControl();
            result_15.init(data);
            return result_15;
        }
        var result = new Setting();
        result.init(data);
        return result;
    };
    Setting.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['ControlType'] = this._discriminator;
        if (Array.isArray(this.errors)) {
            data['Errors'] = [];
            for (var _i = 0, _a = this.errors; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Errors'].push(item);
            }
        }
        data['Layout'] = this.layout ? this.layout.toJSON() : undefined;
        data['ColumnDisplayName'] = this.columnDisplayName ? this.columnDisplayName.toJSON() : undefined;
        data['ValueDescription'] = this.valueDescription;
        data['PropertyName'] = this.propertyName;
        data['Submit'] = this.submit;
        if (Array.isArray(this.icons)) {
            data['Icons'] = [];
            for (var _b = 0, _c = this.icons; _b < _c.length; _b++) {
                var item = _c[_b];
                data['Icons'].push(item.toJSON());
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return Setting;
}(AnnotatedObject));
exports.Setting = Setting;
var Layout = /** @class */ (function () {
    function Layout(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Layout.prototype.init = function (_data) {
        if (_data) {
            this.mode = _data['Mode'];
            this.rowHeight = _data['RowHeight'];
            this.maxRowHeight = _data['MaxRowHeight'];
        }
    };
    Layout.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Layout();
        result.init(data);
        return result;
    };
    Layout.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Mode'] = this.mode;
        data['RowHeight'] = this.rowHeight;
        data['MaxRowHeight'] = this.maxRowHeight;
        return data;
    };
    return Layout;
}());
exports.Layout = Layout;
/** The supported layout modes. */
var LayoutMode;
(function (LayoutMode) {
    LayoutMode["Normal"] = "Normal";
    LayoutMode["FullRow"] = "FullRow";
    LayoutMode["FloatBottom"] = "FloatBottom";
})(LayoutMode = exports.LayoutMode || (exports.LayoutMode = {}));
var ColumnDisplayName = /** @class */ (function () {
    function ColumnDisplayName(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ColumnDisplayName.prototype.init = function (_data) {
        if (_data) {
            this.columnName = _data['ColumnName'];
            this.order = _data['Order'];
            this.isReadOnly = _data['IsReadOnly'];
        }
    };
    ColumnDisplayName.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ColumnDisplayName();
        result.init(data);
        return result;
    };
    ColumnDisplayName.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['ColumnName'] = this.columnName;
        data['Order'] = this.order;
        data['IsReadOnly'] = this.isReadOnly;
        return data;
    };
    return ColumnDisplayName;
}());
exports.ColumnDisplayName = ColumnDisplayName;
var Icon = /** @class */ (function () {
    function Icon(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Icon.prototype.init = function (_data) {
        if (_data) {
            this.iconName = _data['IconName'];
            this.invoke = _data['Invoke'];
            this.stepReference = _data['StepReference'];
            this.propertyReference = _data['PropertyReference'];
        }
    };
    Icon.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Icon();
        result.init(data);
        return result;
    };
    Icon.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['IconName'] = this.iconName;
        data['Invoke'] = this.invoke;
        data['StepReference'] = this.stepReference;
        data['PropertyReference'] = this.propertyReference;
        return data;
    };
    return Icon;
}());
exports.Icon = Icon;
var UnitAttribute = /** @class */ (function () {
    function UnitAttribute(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    UnitAttribute.prototype.init = function (_data) {
        if (_data) {
            this.unit = _data['Unit'];
            this.preScaling = _data['PreScaling'];
            this.stringFormat = _data['StringFormat'];
            this.useRanges = _data['UseRanges'];
            this.useEngineeringPrefix = _data['UseEngineeringPrefix'];
        }
    };
    UnitAttribute.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new UnitAttribute();
        result.init(data);
        return result;
    };
    UnitAttribute.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Unit'] = this.unit;
        data['PreScaling'] = this.preScaling;
        data['StringFormat'] = this.stringFormat;
        data['UseRanges'] = this.useRanges;
        data['UseEngineeringPrefix'] = this.useEngineeringPrefix;
        return data;
    };
    return UnitAttribute;
}());
exports.UnitAttribute = UnitAttribute;
var VisualStatus = /** @class */ (function () {
    function VisualStatus(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    VisualStatus.prototype.init = function (_data) {
        if (_data) {
            this.isReadOnly = _data['IsReadOnly'];
            this.isVisible = _data['IsVisible'];
            this.isEnabled = _data['IsEnabled'];
        }
    };
    VisualStatus.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new VisualStatus();
        result.init(data);
        return result;
    };
    VisualStatus.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['IsReadOnly'] = this.isReadOnly;
        data['IsVisible'] = this.isVisible;
        data['IsEnabled'] = this.isEnabled;
        return data;
    };
    return VisualStatus;
}());
exports.VisualStatus = VisualStatus;
var DisplayAttribute = /** @class */ (function () {
    function DisplayAttribute(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    DisplayAttribute.prototype.init = function (_data) {
        if (_data) {
            this.description = _data['Description'];
            if (Array.isArray(_data['Group'])) {
                this.group = [];
                for (var _i = 0, _a = _data['Group']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.group.push(item);
                }
            }
            this.name = _data['Name'];
            this.order = _data['Order'];
            this.collapsed = _data['Collapsed'];
        }
    };
    DisplayAttribute.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new DisplayAttribute();
        result.init(data);
        return result;
    };
    DisplayAttribute.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Description'] = this.description;
        if (Array.isArray(this.group)) {
            data['Group'] = [];
            for (var _i = 0, _a = this.group; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Group'].push(item);
            }
        }
        data['Name'] = this.name;
        data['Order'] = this.order;
        data['Collapsed'] = this.collapsed;
        return data;
    };
    return DisplayAttribute;
}());
exports.DisplayAttribute = DisplayAttribute;
var MetaData = /** @class */ (function () {
    function MetaData(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    MetaData.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.macroName = _data['MacroName'];
            this.group = _data['Group'];
            this.frozen = _data['Frozen'];
        }
    };
    MetaData.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MetaData();
        result.init(data);
        return result;
    };
    MetaData.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['MacroName'] = this.macroName;
        data['Group'] = this.group;
        data['Frozen'] = this.frozen;
        return data;
    };
    return MetaData;
}());
exports.MetaData = MetaData;
var ExternalParameter = /** @class */ (function () {
    function ExternalParameter(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ExternalParameter.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
        }
    };
    ExternalParameter.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ExternalParameter();
        result.init(data);
        return result;
    };
    ExternalParameter.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        return data;
    };
    return ExternalParameter;
}());
exports.ExternalParameter = ExternalParameter;
var ButtonControl = /** @class */ (function (_super) {
    __extends(ButtonControl, _super);
    function ButtonControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ButtonControl';
        return _this;
    }
    ButtonControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.invokeMethod = _data['InvokeMethod'];
        }
    };
    ButtonControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ButtonControl();
        result.init(data);
        return result;
    };
    ButtonControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['InvokeMethod'] = this.invokeMethod;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ButtonControl;
}(Setting));
exports.ButtonControl = ButtonControl;
var ButtonsControl = /** @class */ (function (_super) {
    __extends(ButtonsControl, _super);
    function ButtonsControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ButtonsControl';
        return _this;
    }
    ButtonsControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['AvailableValues'])) {
                this.availableValues = [];
                for (var _i = 0, _a = _data['AvailableValues']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.availableValues.push(AvailableValue.fromJS(item));
                }
            }
            this.selectedIndex = _data['SelectedIndex'];
            this.invokeMethod = _data['InvokeMethod'];
        }
    };
    ButtonsControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ButtonsControl();
        result.init(data);
        return result;
    };
    ButtonsControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.availableValues)) {
            data['AvailableValues'] = [];
            for (var _i = 0, _a = this.availableValues; _i < _a.length; _i++) {
                var item = _a[_i];
                data['AvailableValues'].push(item.toJSON());
            }
        }
        data['SelectedIndex'] = this.selectedIndex;
        data['InvokeMethod'] = this.invokeMethod;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ButtonsControl;
}(Setting));
exports.ButtonsControl = ButtonsControl;
var AvailableValue = /** @class */ (function () {
    function AvailableValue(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    AvailableValue.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.description = _data['Description'];
        }
    };
    AvailableValue.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new AvailableValue();
        result.init(data);
        return result;
    };
    AvailableValue.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['Description'] = this.description;
        return data;
    };
    return AvailableValue;
}());
exports.AvailableValue = AvailableValue;
var CheckBoxControl = /** @class */ (function (_super) {
    __extends(CheckBoxControl, _super);
    function CheckBoxControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'CheckBoxControl';
        return _this;
    }
    CheckBoxControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.boolValue = _data['BoolValue'];
        }
    };
    CheckBoxControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new CheckBoxControl();
        result.init(data);
        return result;
    };
    CheckBoxControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['BoolValue'] = this.boolValue;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return CheckBoxControl;
}(Setting));
exports.CheckBoxControl = CheckBoxControl;
var DataGridReferenceControl = /** @class */ (function (_super) {
    __extends(DataGridReferenceControl, _super);
    function DataGridReferenceControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'DataGridReferenceControl';
        return _this;
    }
    DataGridReferenceControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    DataGridReferenceControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new DataGridReferenceControl();
        result.init(data);
        return result;
    };
    DataGridReferenceControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return DataGridReferenceControl;
}(Setting));
exports.DataGridReferenceControl = DataGridReferenceControl;
var DataGridControl = /** @class */ (function (_super) {
    __extends(DataGridControl, _super);
    function DataGridControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'DataGridControl';
        return _this;
    }
    DataGridControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Items'])) {
                this.items = [];
                for (var _i = 0, _a = _data['Items']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.items.push(item);
                }
            }
            this.fixedSize = _data['FixedSize'];
        }
    };
    DataGridControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new DataGridControl();
        result.init(data);
        return result;
    };
    DataGridControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data['Items'] = [];
            for (var _i = 0, _a = this.items; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Items'].push(item);
            }
        }
        data['FixedSize'] = this.fixedSize;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return DataGridControl;
}(Setting));
exports.DataGridControl = DataGridControl;
var TextBoxControl = /** @class */ (function (_super) {
    __extends(TextBoxControl, _super);
    function TextBoxControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TextBoxControl';
        return _this;
    }
    TextBoxControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.stringValue = _data['StringValue'];
        }
    };
    TextBoxControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['ControlType'] === 'ComboBoxControl') {
            var result_16 = new ComboBoxControl();
            result_16.init(data);
            return result_16;
        }
        var result = new TextBoxControl();
        result.init(data);
        return result;
    };
    TextBoxControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StringValue'] = this.stringValue;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TextBoxControl;
}(Setting));
exports.TextBoxControl = TextBoxControl;
var ComboBoxControl = /** @class */ (function (_super) {
    __extends(ComboBoxControl, _super);
    function ComboBoxControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ComboBoxControl';
        return _this;
    }
    ComboBoxControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['SuggestedValues'])) {
                this.suggestedValues = [];
                for (var _i = 0, _a = _data['SuggestedValues']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.suggestedValues.push(item);
                }
            }
        }
    };
    ComboBoxControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ComboBoxControl();
        result.init(data);
        return result;
    };
    ComboBoxControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.suggestedValues)) {
            data['SuggestedValues'] = [];
            for (var _i = 0, _a = this.suggestedValues; _i < _a.length; _i++) {
                var item = _a[_i];
                data['SuggestedValues'].push(item);
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ComboBoxControl;
}(TextBoxControl));
exports.ComboBoxControl = ComboBoxControl;
var FilePathControl = /** @class */ (function (_super) {
    __extends(FilePathControl, _super);
    function FilePathControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'FilePathControl';
        return _this;
    }
    FilePathControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.stringValue = _data['StringValue'];
            this.fileExtension = _data['FileExtension'];
        }
    };
    FilePathControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new FilePathControl();
        result.init(data);
        return result;
    };
    FilePathControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StringValue'] = this.stringValue;
        data['FileExtension'] = this.fileExtension;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return FilePathControl;
}(Setting));
exports.FilePathControl = FilePathControl;
var DirectoryPathControl = /** @class */ (function (_super) {
    __extends(DirectoryPathControl, _super);
    function DirectoryPathControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'DirectoryPathControl';
        return _this;
    }
    DirectoryPathControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.stringValue = _data['StringValue'];
        }
    };
    DirectoryPathControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new DirectoryPathControl();
        result.init(data);
        return result;
    };
    DirectoryPathControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StringValue'] = this.stringValue;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return DirectoryPathControl;
}(Setting));
exports.DirectoryPathControl = DirectoryPathControl;
var EnabledControl = /** @class */ (function (_super) {
    __extends(EnabledControl, _super);
    function EnabledControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'EnabledControl';
        return _this;
    }
    EnabledControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.isEnabled = _data['IsEnabled'];
            this.value = _data['Value'] ? Setting.fromJS(_data['Value']) : undefined;
        }
    };
    EnabledControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new EnabledControl();
        result.init(data);
        return result;
    };
    EnabledControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['IsEnabled'] = this.isEnabled;
        data['Value'] = this.value ? this.value.toJSON() : undefined;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return EnabledControl;
}(Setting));
exports.EnabledControl = EnabledControl;
var DropdownControl = /** @class */ (function (_super) {
    __extends(DropdownControl, _super);
    function DropdownControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'DropdownControl';
        return _this;
    }
    DropdownControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['AvailableValues'])) {
                this.availableValues = [];
                for (var _i = 0, _a = _data['AvailableValues']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.availableValues.push(AvailableValue.fromJS(item));
                }
            }
            this.selectedIndex = _data['SelectedIndex'];
        }
    };
    DropdownControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new DropdownControl();
        result.init(data);
        return result;
    };
    DropdownControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.availableValues)) {
            data['AvailableValues'] = [];
            for (var _i = 0, _a = this.availableValues; _i < _a.length; _i++) {
                var item = _a[_i];
                data['AvailableValues'].push(item.toJSON());
            }
        }
        data['SelectedIndex'] = this.selectedIndex;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return DropdownControl;
}(Setting));
exports.DropdownControl = DropdownControl;
var MultiSelectControl = /** @class */ (function (_super) {
    __extends(MultiSelectControl, _super);
    function MultiSelectControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'MultiSelectControl';
        return _this;
    }
    MultiSelectControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['AvailableValues'])) {
                this.availableValues = [];
                for (var _i = 0, _a = _data['AvailableValues']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.availableValues.push(AvailableValue.fromJS(item));
                }
            }
            if (Array.isArray(_data['SelectedIndex'])) {
                this.selectedIndex = [];
                for (var _b = 0, _c = _data['SelectedIndex']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.selectedIndex.push(item);
                }
            }
        }
    };
    MultiSelectControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MultiSelectControl();
        result.init(data);
        return result;
    };
    MultiSelectControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.availableValues)) {
            data['AvailableValues'] = [];
            for (var _i = 0, _a = this.availableValues; _i < _a.length; _i++) {
                var item = _a[_i];
                data['AvailableValues'].push(item.toJSON());
            }
        }
        if (Array.isArray(this.selectedIndex)) {
            data['SelectedIndex'] = [];
            for (var _b = 0, _c = this.selectedIndex; _b < _c.length; _b++) {
                var item = _c[_b];
                data['SelectedIndex'].push(item);
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return MultiSelectControl;
}(Setting));
exports.MultiSelectControl = MultiSelectControl;
var PasswordControl = /** @class */ (function (_super) {
    __extends(PasswordControl, _super);
    function PasswordControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'PasswordControl';
        return _this;
    }
    PasswordControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.password = _data['Password'];
        }
    };
    PasswordControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new PasswordControl();
        result.init(data);
        return result;
    };
    PasswordControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Password'] = this.password;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return PasswordControl;
}(Setting));
exports.PasswordControl = PasswordControl;
var PictureControl = /** @class */ (function (_super) {
    __extends(PictureControl, _super);
    function PictureControl(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'PictureControl';
        return _this;
    }
    PictureControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.description = _data['Description'];
            this.mimeType = _data['MimeType'];
            this.resource = _data['Resource'] ? Resource.fromJS(_data['Resource']) : undefined;
        }
    };
    PictureControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new PictureControl();
        result.init(data);
        return result;
    };
    PictureControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Description'] = this.description;
        data['MimeType'] = this.mimeType;
        data['Resource'] = this.resource ? this.resource.toJSON() : undefined;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return PictureControl;
}(Setting));
exports.PictureControl = PictureControl;
var PluginTypeSelectorControl = /** @class */ (function (_super) {
    __extends(PluginTypeSelectorControl, _super);
    function PluginTypeSelectorControl(data) {
        var _this = _super.call(this, data) || this;
        _this.availableValues = [];
        _this._discriminator = 'PluginTypeSelectorControl';
        return _this;
    }
    PluginTypeSelectorControl.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['AvailableValues'])) {
                this.availableValues = [];
                for (var _i = 0, _a = _data['AvailableValues']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.availableValues.push(AvailableValue.fromJS(item));
                }
            }
            this.selectedIndex = _data['SelectedIndex'];
        }
    };
    PluginTypeSelectorControl.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new PluginTypeSelectorControl();
        result.init(data);
        return result;
    };
    PluginTypeSelectorControl.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.availableValues)) {
            data['AvailableValues'] = [];
            for (var _i = 0, _a = this.availableValues; _i < _a.length; _i++) {
                var item = _a[_i];
                data['AvailableValues'].push(item.toJSON());
            }
        }
        data['SelectedIndex'] = this.selectedIndex;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return PluginTypeSelectorControl;
}(Setting));
exports.PluginTypeSelectorControl = PluginTypeSelectorControl;
var Resource = /** @class */ (function () {
    function Resource(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Resource.prototype.init = function (_data) {
        if (_data) {
            this.source = _data['Source'];
        }
    };
    Resource.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Resource();
        result.init(data);
        return result;
    };
    Resource.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Source'] = this.source;
        return data;
    };
    return Resource;
}());
exports.Resource = Resource;
var FileDescriptor = /** @class */ (function () {
    function FileDescriptor(fileSize, chunkSize) {
        var _a;
        if (chunkSize === 0) {
            throw Error('chunkSize cannot set to 0');
        }
        this.fileSize = fileSize;
        this.chunkSize = chunkSize;
        this.numberOfChunks = Math.floor((((_a = this.fileSize) !== null && _a !== void 0 ? _a : 0) + this.chunkSize - 1) / this.chunkSize);
    }
    FileDescriptor.prototype.init = function (_data) {
        if (_data) {
            this.numberOfChunks = _data['NumberOfChunks'];
            this.fileSize = _data['FileSize'];
            this.chunkSize = _data['ChunkSize'];
        }
    };
    FileDescriptor.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new FileDescriptor(0, 512000);
        result.init(data);
        return result;
    };
    FileDescriptor.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['NumberOfChunks'] = this.numberOfChunks;
        data['FileSize'] = this.fileSize;
        data['ChunkSize'] = this.chunkSize;
        return data;
    };
    return FileDescriptor;
}());
exports.FileDescriptor = FileDescriptor;
var ComponentSettings = /** @class */ (function (_super) {
    __extends(ComponentSettings, _super);
    function ComponentSettings(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ComponentSettings';
        return _this;
    }
    ComponentSettings.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Settings'])) {
                this.settings = [];
                for (var _i = 0, _a = _data['Settings']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.settings.push(Setting.fromJS(item));
                }
            }
        }
    };
    ComponentSettings.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ComponentSettings();
        result.init(data);
        return result;
    };
    ComponentSettings.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.settings)) {
            data['Settings'] = [];
            for (var _i = 0, _a = this.settings; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Settings'].push(item.toJSON());
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ComponentSettings;
}(ComponentSettingsBase));
exports.ComponentSettings = ComponentSettings;
var ListItemType = /** @class */ (function () {
    function ListItemType(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ListItemType.prototype.init = function (_data) {
        if (_data) {
            this.typeName = _data['TypeName'];
            this.typeDisplay = _data['TypeDisplay'] ? DisplayAttribute.fromJS(_data['TypeDisplay']) : undefined;
        }
    };
    ListItemType.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ListItemType();
        result.init(data);
        return result;
    };
    ListItemType.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['TypeName'] = this.typeName;
        data['TypeDisplay'] = this.typeDisplay ? this.typeDisplay.toJSON() : undefined;
        return data;
    };
    return ListItemType;
}());
exports.ListItemType = ListItemType;
var ProfileGroup = /** @class */ (function () {
    function ProfileGroup(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ProfileGroup.prototype.init = function (_data) {
        if (_data) {
            if (Array.isArray(_data['Profiles'])) {
                this.profiles = [];
                for (var _i = 0, _a = _data['Profiles']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.profiles.push(item);
                }
            }
            this.currentProfile = _data['CurrentProfile'];
            this.groupName = _data['GroupName'];
        }
    };
    ProfileGroup.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ProfileGroup();
        result.init(data);
        return result;
    };
    ProfileGroup.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.profiles)) {
            data['Profiles'] = [];
            for (var _i = 0, _a = this.profiles; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Profiles'].push(item);
            }
        }
        data['CurrentProfile'] = this.currentProfile;
        data['GroupName'] = this.groupName;
        return data;
    };
    return ProfileGroup;
}());
exports.ProfileGroup = ProfileGroup;
var RepositoryPackageReference = /** @class */ (function () {
    function RepositoryPackageReference(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    RepositoryPackageReference.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.version = _data['Version'];
            this.repository = _data['Repository'];
            this.path = _data['Path'];
        }
    };
    RepositoryPackageReference.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RepositoryPackageReference();
        result.init(data);
        return result;
    };
    RepositoryPackageReference.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['Version'] = this.version;
        data['Repository'] = this.repository;
        data['Path'] = this.path;
        return data;
    };
    return RepositoryPackageReference;
}());
exports.RepositoryPackageReference = RepositoryPackageReference;
var RepositoryPackageDefinition = /** @class */ (function (_super) {
    __extends(RepositoryPackageDefinition, _super);
    function RepositoryPackageDefinition(data) {
        return _super.call(this, data) || this;
    }
    RepositoryPackageDefinition.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Tags'])) {
                this.tags = [];
                for (var _i = 0, _a = _data['Tags']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.tags.push(item);
                }
            }
        }
    };
    RepositoryPackageDefinition.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RepositoryPackageDefinition();
        result.init(data);
        return result;
    };
    RepositoryPackageDefinition.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.tags)) {
            data['Tags'] = [];
            for (var _i = 0, _a = this.tags; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Tags'].push(item);
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return RepositoryPackageDefinition;
}(RepositoryPackageReference));
exports.RepositoryPackageDefinition = RepositoryPackageDefinition;
var RepositorySettingsPackageDefinition = /** @class */ (function (_super) {
    __extends(RepositorySettingsPackageDefinition, _super);
    function RepositorySettingsPackageDefinition(data) {
        return _super.call(this, data) || this;
    }
    RepositorySettingsPackageDefinition.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    RepositorySettingsPackageDefinition.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RepositorySettingsPackageDefinition();
        result.init(data);
        return result;
    };
    RepositorySettingsPackageDefinition.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return RepositorySettingsPackageDefinition;
}(RepositoryPackageDefinition));
exports.RepositorySettingsPackageDefinition = RepositorySettingsPackageDefinition;
var SettingsTapPackage = /** @class */ (function () {
    function SettingsTapPackage(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    SettingsTapPackage.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.version = _data['Version'];
            this.tags = _data['Tags'];
            this.group = _data['Group'];
            this.owner = _data['Owner'];
            this.infoLink = _data['InfoLink'];
            this.description = _data['Description'];
            if (Array.isArray(_data['Files'])) {
                this.files = [];
                for (var _i = 0, _a = _data['Files']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.files.push(item);
                }
            }
            if (Array.isArray(_data['SettingsTypes'])) {
                this.settingsTypes = [];
                for (var _b = 0, _c = _data['SettingsTypes']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.settingsTypes.push(item);
                }
            }
        }
    };
    SettingsTapPackage.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SettingsTapPackage();
        result.init(data);
        return result;
    };
    SettingsTapPackage.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['Version'] = this.version;
        data['Tags'] = this.tags;
        data['Group'] = this.group;
        data['Owner'] = this.owner;
        data['InfoLink'] = this.infoLink;
        data['Description'] = this.description;
        if (Array.isArray(this.files)) {
            data['Files'] = [];
            for (var _i = 0, _a = this.files; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Files'].push(item);
            }
        }
        if (Array.isArray(this.settingsTypes)) {
            data['SettingsTypes'] = [];
            for (var _b = 0, _c = this.settingsTypes; _b < _c.length; _b++) {
                var item = _c[_b];
                data['SettingsTypes'].push(item);
            }
        }
        return data;
    };
    return SettingsTapPackage;
}());
exports.SettingsTapPackage = SettingsTapPackage;
var SessionEventArgs = /** @class */ (function () {
    function SessionEventArgs(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'SessionEventArgs';
    }
    SessionEventArgs.prototype.init = function (_data) {
        if (_data) {
            this.sessionId = _data['SessionId'];
        }
    };
    SessionEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['SessionEventType'] === 'SessionStartInitiated') {
            var result_17 = new SessionStartInitiated();
            result_17.init(data);
            return result_17;
        }
        if (data['SessionEventType'] === 'SessionStarted') {
            var result_18 = new SessionStarted();
            result_18.init(data);
            return result_18;
        }
        if (data['SessionEventType'] === 'SessionStartFailed') {
            var result_19 = new SessionStartFailed();
            result_19.init(data);
            return result_19;
        }
        if (data['SessionEventType'] === 'SessionShutdownInitiated') {
            var result_20 = new SessionShutdownInitiated();
            result_20.init(data);
            return result_20;
        }
        if (data['SessionEventType'] === 'SessionShutdown') {
            var result_21 = new SessionShutdown();
            result_21.init(data);
            return result_21;
        }
        if (data['SessionEventType'] === 'SessionShutdownFailed') {
            var result_22 = new SessionShutdownFailed();
            result_22.init(data);
            return result_22;
        }
        if (data['SessionEventType'] === 'SessionInactivityLimitHit') {
            var result_23 = new SessionInactivityLimitHit();
            result_23.init(data);
            return result_23;
        }
        var result = new SessionEventArgs();
        result.init(data);
        return result;
    };
    SessionEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['SessionEventType'] = this._discriminator;
        data['SessionId'] = this.sessionId;
        return data;
    };
    return SessionEventArgs;
}());
exports.SessionEventArgs = SessionEventArgs;
var SessionStartInitiated = /** @class */ (function (_super) {
    __extends(SessionStartInitiated, _super);
    function SessionStartInitiated(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionStartInitiated';
        return _this;
    }
    SessionStartInitiated.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SessionStartInitiated.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionStartInitiated();
        result.init(data);
        return result;
    };
    SessionStartInitiated.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionStartInitiated;
}(SessionEventArgs));
exports.SessionStartInitiated = SessionStartInitiated;
var SessionStarted = /** @class */ (function (_super) {
    __extends(SessionStarted, _super);
    function SessionStarted(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionStarted';
        return _this;
    }
    SessionStarted.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.session = _data['Session'] ? Session.fromJS(_data['Session']) : undefined;
        }
    };
    SessionStarted.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionStarted();
        result.init(data);
        return result;
    };
    SessionStarted.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Session'] = this.session ? this.session.toJSON() : undefined;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionStarted;
}(SessionEventArgs));
exports.SessionStarted = SessionStarted;
var SessionStartFailed = /** @class */ (function (_super) {
    __extends(SessionStartFailed, _super);
    function SessionStartFailed(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionStartFailed';
        return _this;
    }
    SessionStartFailed.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.reason = _data['Reason'];
        }
    };
    SessionStartFailed.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionStartFailed();
        result.init(data);
        return result;
    };
    SessionStartFailed.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Reason'] = this.reason;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionStartFailed;
}(SessionEventArgs));
exports.SessionStartFailed = SessionStartFailed;
var SessionShutdownInitiated = /** @class */ (function (_super) {
    __extends(SessionShutdownInitiated, _super);
    function SessionShutdownInitiated(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionShutdownInitiated';
        return _this;
    }
    SessionShutdownInitiated.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SessionShutdownInitiated.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionShutdownInitiated();
        result.init(data);
        return result;
    };
    SessionShutdownInitiated.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionShutdownInitiated;
}(SessionEventArgs));
exports.SessionShutdownInitiated = SessionShutdownInitiated;
var SessionShutdown = /** @class */ (function (_super) {
    __extends(SessionShutdown, _super);
    function SessionShutdown(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionShutdown';
        return _this;
    }
    SessionShutdown.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SessionShutdown.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionShutdown();
        result.init(data);
        return result;
    };
    SessionShutdown.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionShutdown;
}(SessionEventArgs));
exports.SessionShutdown = SessionShutdown;
var SessionShutdownFailed = /** @class */ (function (_super) {
    __extends(SessionShutdownFailed, _super);
    function SessionShutdownFailed(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionShutdownFailed';
        return _this;
    }
    SessionShutdownFailed.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.reason = _data['Reason'];
        }
    };
    SessionShutdownFailed.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionShutdownFailed();
        result.init(data);
        return result;
    };
    SessionShutdownFailed.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Reason'] = this.reason;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionShutdownFailed;
}(SessionEventArgs));
exports.SessionShutdownFailed = SessionShutdownFailed;
var SessionInactivityLimitHit = /** @class */ (function (_super) {
    __extends(SessionInactivityLimitHit, _super);
    function SessionInactivityLimitHit(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionInactivityLimitHit';
        return _this;
    }
    SessionInactivityLimitHit.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SessionInactivityLimitHit.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionInactivityLimitHit();
        result.init(data);
        return result;
    };
    SessionInactivityLimitHit.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionInactivityLimitHit;
}(SessionEventArgs));
exports.SessionInactivityLimitHit = SessionInactivityLimitHit;
var ImageEventArgs = /** @class */ (function () {
    function ImageEventArgs(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'ImageEventArgs';
    }
    ImageEventArgs.prototype.init = function (_data) {
        if (_data) {
            this.imageId = _data['ImageId'];
        }
    };
    ImageEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['ImageEventType'] === 'ImageCreating') {
            var result_24 = new ImageCreating();
            result_24.init(data);
            return result_24;
        }
        if (data['ImageEventType'] === 'ImageCreated') {
            var result_25 = new ImageCreated();
            result_25.init(data);
            return result_25;
        }
        if (data['ImageEventType'] === 'ImageCreationFailed') {
            var result_26 = new ImageCreationFailed();
            result_26.init(data);
            return result_26;
        }
        var result = new ImageEventArgs();
        result.init(data);
        return result;
    };
    ImageEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['ImageEventType'] = this._discriminator;
        data['ImageId'] = this.imageId;
        return data;
    };
    return ImageEventArgs;
}());
exports.ImageEventArgs = ImageEventArgs;
var ImageCreating = /** @class */ (function (_super) {
    __extends(ImageCreating, _super);
    function ImageCreating(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ImageCreating';
        return _this;
    }
    ImageCreating.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    ImageCreating.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ImageCreating();
        result.init(data);
        return result;
    };
    ImageCreating.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ImageCreating;
}(ImageEventArgs));
exports.ImageCreating = ImageCreating;
var ImageCreated = /** @class */ (function (_super) {
    __extends(ImageCreated, _super);
    function ImageCreated(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ImageCreated';
        return _this;
    }
    ImageCreated.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.image = _data['Image'] ? Image.fromJS(_data['Image']) : undefined;
        }
    };
    ImageCreated.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ImageCreated();
        result.init(data);
        return result;
    };
    ImageCreated.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Image'] = this.image ? this.image.toJSON() : undefined;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ImageCreated;
}(ImageEventArgs));
exports.ImageCreated = ImageCreated;
var ImageCreationFailed = /** @class */ (function (_super) {
    __extends(ImageCreationFailed, _super);
    function ImageCreationFailed(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'ImageCreationFailed';
        return _this;
    }
    ImageCreationFailed.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.reason = _data['Reason'];
        }
    };
    ImageCreationFailed.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ImageCreationFailed();
        result.init(data);
        return result;
    };
    ImageCreationFailed.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Reason'] = this.reason;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return ImageCreationFailed;
}(ImageEventArgs));
exports.ImageCreationFailed = ImageCreationFailed;
var ApiException = /** @class */ (function (_super) {
    __extends(ApiException, _super);
    function ApiException(message, status, response, headers, result) {
        var _this = _super.call(this) || this;
        _this.isApiException = true;
        _this.message = message;
        _this.status = status;
        _this.response = response;
        _this.headers = headers;
        _this.result = result;
        return _this;
    }
    ApiException.isApiException = function (obj) {
        return obj.isApiException === true;
    };
    return ApiException;
}(Error));
exports.ApiException = ApiException;
var LogList = /** @class */ (function () {
    function LogList(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    LogList.prototype.init = function (_data) {
        if (_data) {
            if (Array.isArray(_data['Logs'])) {
                this.logs = [];
                for (var _i = 0, _a = _data['Logs']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.logs.push(LogEntry.fromJS(item));
                }
            }
            this.offset = _data['Offset'];
            this.filteredCount = _data['FilteredCount'];
            if (_data['TotalCount']) {
                this.totalCount = {};
                for (var key in _data['TotalCount']) {
                    if (Object.prototype.hasOwnProperty.call(_data['TotalCount'], key))
                        this.totalCount[key] = _data['TotalCount'][key];
                }
            }
        }
    };
    LogList.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new LogList();
        result.init(data);
        return result;
    };
    LogList.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.logs)) {
            data['Logs'] = [];
            for (var _i = 0, _a = this.logs; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Logs'].push(item.toJSON());
            }
        }
        data['Offset'] = this.offset;
        data['FilteredCount'] = this.filteredCount;
        if (this.totalCount) {
            data['TotalCount'] = {};
            for (var key in this.totalCount) {
                if (Object.prototype.hasOwnProperty.call(this.totalCount, key))
                    data['TotalCount'][key] = this.totalCount[key];
            }
        }
        return data;
    };
    return LogList;
}());
exports.LogList = LogList;
var LogEntry = /** @class */ (function () {
    function LogEntry(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    LogEntry.prototype.init = function (_data) {
        if (_data) {
            this.source = _data['Source'];
            this.timestamp = _data['Timestamp'];
            this.message = _data['Message'];
            this.level = _data['Level'];
            this.durationNS = _data['DurationNS'];
        }
    };
    LogEntry.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new LogEntry();
        result.init(data);
        return result;
    };
    LogEntry.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Source'] = this.source;
        data['Timestamp'] = this.timestamp;
        data['Message'] = this.message;
        data['Level'] = this.level;
        data['DurationNS'] = this.durationNS;
        return data;
    };
    return LogEntry;
}());
exports.LogEntry = LogEntry;
var MissingLicenseResponse = /** @class */ (function () {
    function MissingLicenseResponse(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    MissingLicenseResponse.prototype.init = function (_data) {
        if (_data) {
            this.message = _data['Message'];
        }
    };
    MissingLicenseResponse.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MissingLicenseResponse();
        result.init(data);
        return result;
    };
    MissingLicenseResponse.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Message'] = this.message;
        return data;
    };
    return MissingLicenseResponse;
}());
exports.MissingLicenseResponse = MissingLicenseResponse;
var RunStatus = /** @class */ (function () {
    function RunStatus(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    RunStatus.prototype.init = function (_data) {
        if (_data) {
            this.sessionId = _data['SessionId'];
            this.verdict = _data['Verdict'];
            this.testPlanRunId = _data['TestPlanRunId'];
            this.failedToStart = _data['FailedToStart'];
            this.executionState = _data['ExecutionState'];
            if (Array.isArray(_data['ExecutingSteps'])) {
                this.executingSteps = [];
                for (var _i = 0, _a = _data['ExecutingSteps']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.executingSteps.push(item);
                }
            }
        }
    };
    RunStatus.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RunStatus();
        result.init(data);
        return result;
    };
    RunStatus.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['SessionId'] = this.sessionId;
        data['Verdict'] = this.verdict;
        data['TestPlanRunId'] = this.testPlanRunId;
        data['FailedToStart'] = this.failedToStart;
        data['ExecutionState'] = this.executionState;
        if (Array.isArray(this.executingSteps)) {
            data['ExecutingSteps'] = [];
            for (var _i = 0, _a = this.executingSteps; _i < _a.length; _i++) {
                var item = _a[_i];
                data['ExecutingSteps'].push(item);
            }
        }
        return data;
    };
    return RunStatus;
}());
exports.RunStatus = RunStatus;
/** Enumeration containing the verdict types used for Verdict and Verdict properties. */
var Verdict;
(function (Verdict) {
    Verdict["NotSet"] = "NotSet";
    Verdict["Pass"] = "Pass";
    Verdict["Inconclusive"] = "Inconclusive";
    Verdict["Fail"] = "Fail";
    Verdict["Aborted"] = "Aborted";
    Verdict["Error"] = "Error";
})(Verdict = exports.Verdict || (exports.Verdict = {}));
var ExecutionState;
(function (ExecutionState) {
    ExecutionState["Idle"] = "Idle";
    ExecutionState["Executing"] = "Executing";
    ExecutionState["Breaking"] = "Breaking";
    ExecutionState["Aborting"] = "Aborting";
    ExecutionState["WaitingForUserInput"] = "WaitingForUserInput";
})(ExecutionState = exports.ExecutionState || (exports.ExecutionState = {}));
var TestPlan = /** @class */ (function () {
    function TestPlan(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    TestPlan.prototype.init = function (_data) {
        if (_data) {
            if (Array.isArray(_data['ChildTestSteps'])) {
                this.childTestSteps = [];
                for (var _i = 0, _a = _data['ChildTestSteps']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.childTestSteps.push(TestStep.fromJS(item));
                }
            }
            if (Array.isArray(_data['Settings'])) {
                this.settings = [];
                for (var _b = 0, _c = _data['Settings']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.settings.push(Setting.fromJS(item));
                }
            }
            this.isOpen = _data['IsOpen'];
            if (Array.isArray(_data['PropertiesToInclude'])) {
                this.propertiesToInclude = [];
                for (var _d = 0, _e = _data['PropertiesToInclude']; _d < _e.length; _d++) {
                    var item = _e[_d];
                    this.propertiesToInclude.push(item);
                }
            }
            this.id = _data['Id'];
        }
    };
    TestPlan.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlan();
        result.init(data);
        return result;
    };
    TestPlan.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.childTestSteps)) {
            data['ChildTestSteps'] = [];
            for (var _i = 0, _a = this.childTestSteps; _i < _a.length; _i++) {
                var item = _a[_i];
                data['ChildTestSteps'].push(item.toJSON());
            }
        }
        if (Array.isArray(this.settings)) {
            data['Settings'] = [];
            for (var _b = 0, _c = this.settings; _b < _c.length; _b++) {
                var item = _c[_b];
                data['Settings'].push(item.toJSON());
            }
        }
        data['IsOpen'] = this.isOpen;
        if (Array.isArray(this.propertiesToInclude)) {
            data['PropertiesToInclude'] = [];
            for (var _d = 0, _e = this.propertiesToInclude; _d < _e.length; _d++) {
                var item = _e[_d];
                data['PropertiesToInclude'].push(item);
            }
        }
        data['Id'] = this.id;
        return data;
    };
    return TestPlan;
}());
exports.TestPlan = TestPlan;
var TestStep = /** @class */ (function () {
    function TestStep(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'TestStep';
    }
    TestStep.prototype.init = function (_data) {
        if (_data) {
            this.id = _data['Id'];
            if (Array.isArray(_data['ChildTestSteps'])) {
                this.childTestSteps = [];
                for (var _i = 0, _a = _data['ChildTestSteps']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.childTestSteps.push(TestStep.fromJS(item));
                }
            }
            this.isChildTestStepsReadOnly = _data['IsChildTestStepsReadOnly'];
            this.isReadOnly = _data['IsReadOnly'];
            if (Array.isArray(_data['Settings'])) {
                this.settings = [];
                for (var _b = 0, _c = _data['Settings']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.settings.push(Setting.fromJS(item));
                }
            }
            this.typeName = _data['TypeName'];
            this.typeDisplay = _data['TypeDisplay'] ? DisplayAttribute.fromJS(_data['TypeDisplay']) : undefined;
            this.name = _data['Name'];
            this.expandedName = _data['ExpandedName'];
        }
    };
    TestStep.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['TestStepTypeOrInstance'] === 'TestStepType') {
            var result_27 = new TestStepType();
            result_27.init(data);
            return result_27;
        }
        var result = new TestStep();
        result.init(data);
        return result;
    };
    TestStep.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['TestStepTypeOrInstance'] = this._discriminator;
        data['Id'] = this.id;
        if (Array.isArray(this.childTestSteps)) {
            data['ChildTestSteps'] = [];
            for (var _i = 0, _a = this.childTestSteps; _i < _a.length; _i++) {
                var item = _a[_i];
                data['ChildTestSteps'].push(item.toJSON());
            }
        }
        data['IsChildTestStepsReadOnly'] = this.isChildTestStepsReadOnly;
        data['IsReadOnly'] = this.isReadOnly;
        if (Array.isArray(this.settings)) {
            data['Settings'] = [];
            for (var _b = 0, _c = this.settings; _b < _c.length; _b++) {
                var item = _c[_b];
                data['Settings'].push(item.toJSON());
            }
        }
        data['TypeName'] = this.typeName;
        data['TypeDisplay'] = this.typeDisplay ? this.typeDisplay.toJSON() : undefined;
        data['Name'] = this.name;
        data['ExpandedName'] = this.expandedName;
        return data;
    };
    return TestStep;
}());
exports.TestStep = TestStep;
var TestStepType = /** @class */ (function (_super) {
    __extends(TestStepType, _super);
    function TestStepType(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestStepType';
        return _this;
    }
    TestStepType.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['AvailableChildrenTypes'])) {
                this.availableChildrenTypes = [];
                for (var _i = 0, _a = _data['AvailableChildrenTypes']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.availableChildrenTypes.push(item);
                }
            }
        }
    };
    TestStepType.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepType();
        result.init(data);
        return result;
    };
    TestStepType.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.availableChildrenTypes)) {
            data['AvailableChildrenTypes'] = [];
            for (var _i = 0, _a = this.availableChildrenTypes; _i < _a.length; _i++) {
                var item = _a[_i];
                data['AvailableChildrenTypes'].push(item);
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestStepType;
}(TestStep));
exports.TestStepType = TestStepType;
var TestStepCopy = /** @class */ (function (_super) {
    __extends(TestStepCopy, _super);
    function TestStepCopy(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestStepCopy';
        return _this;
    }
    TestStepCopy.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestStepCopy.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepCopy();
        result.init(data);
        return result;
    };
    TestStepCopy.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestStepCopy;
}(TestStep));
exports.TestStepCopy = TestStepCopy;
var TestStepValidationError = /** @class */ (function () {
    function TestStepValidationError(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    TestStepValidationError.prototype.init = function (_data) {
        if (_data) {
            this.stepId = _data['StepId'];
            if (Array.isArray(_data['ValidationErrors'])) {
                this.validationErrors = [];
                for (var _i = 0, _a = _data['ValidationErrors']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.validationErrors.push(ValidationError.fromJS(item));
                }
            }
        }
    };
    TestStepValidationError.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepValidationError();
        result.init(data);
        return result;
    };
    TestStepValidationError.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StepId'] = this.stepId;
        if (Array.isArray(this.validationErrors)) {
            data['ValidationErrors'] = [];
            for (var _i = 0, _a = this.validationErrors; _i < _a.length; _i++) {
                var item = _a[_i];
                data['ValidationErrors'].push(item.toJSON());
            }
        }
        return data;
    };
    return TestStepValidationError;
}());
exports.TestStepValidationError = TestStepValidationError;
var ValidationError = /** @class */ (function () {
    function ValidationError(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ValidationError.prototype.init = function (_data) {
        if (_data) {
            this.propertyName = _data['PropertyName'];
            this.error = _data['Error'];
        }
    };
    ValidationError.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ValidationError();
        result.init(data);
        return result;
    };
    ValidationError.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['PropertyName'] = this.propertyName;
        data['Error'] = this.error;
        return data;
    };
    return ValidationError;
}());
exports.ValidationError = ValidationError;
var CommonSettings = /** @class */ (function () {
    function CommonSettings(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    CommonSettings.prototype.init = function (_data) {
        if (_data) {
            this.step = _data['Step'] ? TestStep.fromJS(_data['Step']) : undefined;
            if (Array.isArray(_data['StepIds'])) {
                this.stepIds = [];
                for (var _i = 0, _a = _data['StepIds']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.stepIds.push(item);
                }
            }
        }
    };
    CommonSettings.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new CommonSettings();
        result.init(data);
        return result;
    };
    CommonSettings.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Step'] = this.step ? this.step.toJSON() : undefined;
        if (Array.isArray(this.stepIds)) {
            data['StepIds'] = [];
            for (var _i = 0, _a = this.stepIds; _i < _a.length; _i++) {
                var item = _a[_i];
                data['StepIds'].push(item);
            }
        }
        return data;
    };
    return CommonSettings;
}());
exports.CommonSettings = CommonSettings;
var CommonContext = /** @class */ (function () {
    function CommonContext(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    CommonContext.prototype.init = function (_data) {
        if (_data) {
            if (Array.isArray(_data['ContextItems'])) {
                this.contextItems = [];
                for (var _i = 0, _a = _data['ContextItems']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.contextItems.push(Setting.fromJS(item));
                }
            }
            if (Array.isArray(_data['StepIds'])) {
                this.stepIds = [];
                for (var _b = 0, _c = _data['StepIds']; _b < _c.length; _b++) {
                    var item = _c[_b];
                    this.stepIds.push(item);
                }
            }
        }
    };
    CommonContext.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new CommonContext();
        result.init(data);
        return result;
    };
    CommonContext.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.contextItems)) {
            data['ContextItems'] = [];
            for (var _i = 0, _a = this.contextItems; _i < _a.length; _i++) {
                var item = _a[_i];
                data['ContextItems'].push(item.toJSON());
            }
        }
        if (Array.isArray(this.stepIds)) {
            data['StepIds'] = [];
            for (var _b = 0, _c = this.stepIds; _b < _c.length; _b++) {
                var item = _c[_b];
                data['StepIds'].push(item);
            }
        }
        return data;
    };
    return CommonContext;
}());
exports.CommonContext = CommonContext;
var Interaction = /** @class */ (function () {
    function Interaction(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Interaction.prototype.init = function (_data) {
        if (_data) {
            this.timeout = _data['Timeout'];
            this.title = _data['Title'];
            this.modal = _data['Modal'];
            if (Array.isArray(_data['Settings'])) {
                this.settings = [];
                for (var _i = 0, _a = _data['Settings']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.settings.push(Setting.fromJS(item));
                }
            }
            this.id = _data['Id'];
        }
    };
    Interaction.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Interaction();
        result.init(data);
        return result;
    };
    Interaction.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Timeout'] = this.timeout;
        data['Title'] = this.title;
        data['Modal'] = this.modal;
        if (Array.isArray(this.settings)) {
            data['Settings'] = [];
            for (var _i = 0, _a = this.settings; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Settings'].push(item.toJSON());
            }
        }
        data['Id'] = this.id;
        return data;
    };
    return Interaction;
}());
exports.Interaction = Interaction;
var InstalledFile = /** @class */ (function () {
    function InstalledFile(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    InstalledFile.prototype.init = function (_data) {
        if (_data) {
            this.relativePath = _data['RelativePath'];
            this.tapPackage = _data['TapPackage'];
        }
    };
    InstalledFile.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new InstalledFile();
        result.init(data);
        return result;
    };
    InstalledFile.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['RelativePath'] = this.relativePath;
        data['TapPackage'] = this.tapPackage;
        return data;
    };
    return InstalledFile;
}());
exports.InstalledFile = InstalledFile;
var BreakPoints = /** @class */ (function () {
    function BreakPoints(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    BreakPoints.prototype.init = function (_data) {
        if (_data) {
            if (Array.isArray(_data['TestSteps'])) {
                this.testSteps = [];
                for (var _i = 0, _a = _data['TestSteps']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.testSteps.push(item);
                }
            }
        }
    };
    BreakPoints.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new BreakPoints();
        result.init(data);
        return result;
    };
    BreakPoints.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.testSteps)) {
            data['TestSteps'] = [];
            for (var _i = 0, _a = this.testSteps; _i < _a.length; _i++) {
                var item = _a[_i];
                data['TestSteps'].push(item);
            }
        }
        return data;
    };
    return BreakPoints;
}());
exports.BreakPoints = BreakPoints;
var Parameter = /** @class */ (function () {
    function Parameter(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Parameter.prototype.init = function (_data) {
        if (_data) {
            this.group = _data['Group'];
            this.name = _data['Name'];
            this.macroName = _data['MacroName'];
            this.parentLevel = _data['ParentLevel'];
            this.value = _data['Value'];
        }
    };
    Parameter.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Parameter();
        result.init(data);
        return result;
    };
    Parameter.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Group'] = this.group;
        data['Name'] = this.name;
        data['MacroName'] = this.macroName;
        data['ParentLevel'] = this.parentLevel;
        data['Value'] = this.value;
        return data;
    };
    return Parameter;
}());
exports.Parameter = Parameter;
var WatchDog = /** @class */ (function () {
    function WatchDog(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    WatchDog.prototype.init = function (_data) {
        if (_data) {
            this.inactiveSeconds = _data['InactiveSeconds'];
            this.terminationTimeout = _data['TerminationTimeout'];
        }
    };
    WatchDog.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new WatchDog();
        result.init(data);
        return result;
    };
    WatchDog.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['InactiveSeconds'] = this.inactiveSeconds;
        data['TerminationTimeout'] = this.terminationTimeout;
        return data;
    };
    return WatchDog;
}());
exports.WatchDog = WatchDog;
var TestRun = /** @class */ (function () {
    function TestRun(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    TestRun.prototype.init = function (_data) {
        if (_data) {
            this.status = _data['Status'];
            this.id = _data['Id'];
            this.verdict = _data['Verdict'];
            this.duration = _data['Duration'];
            if (Array.isArray(_data['Parameters'])) {
                this.parameters = [];
                for (var _i = 0, _a = _data['Parameters']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.parameters.push(Parameter.fromJS(item));
                }
            }
            this.testStepRun = _data['TestStepRun'] ? TestStepRun.fromJS(_data['TestStepRun']) : undefined;
        }
    };
    TestRun.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestRun();
        result.init(data);
        return result;
    };
    TestRun.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Status'] = this.status;
        data['Id'] = this.id;
        data['Verdict'] = this.verdict;
        data['Duration'] = this.duration;
        if (Array.isArray(this.parameters)) {
            data['Parameters'] = [];
            for (var _i = 0, _a = this.parameters; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Parameters'].push(item.toJSON());
            }
        }
        data['TestStepRun'] = this.testStepRun ? this.testStepRun.toJSON() : undefined;
        return data;
    };
    return TestRun;
}());
exports.TestRun = TestRun;
var TestStepRun = /** @class */ (function () {
    function TestStepRun(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    TestStepRun.prototype.init = function (_data) {
        if (_data) {
            this.parentId = _data['ParentId'];
            this.testStepId = _data['TestStepId'];
            this.testStepName = _data['TestStepName'];
        }
    };
    TestStepRun.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepRun();
        result.init(data);
        return result;
    };
    TestStepRun.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['ParentId'] = this.parentId;
        data['TestStepId'] = this.testStepId;
        data['TestStepName'] = this.testStepName;
        return data;
    };
    return TestStepRun;
}());
exports.TestStepRun = TestStepRun;
var LogEvent = /** @class */ (function () {
    function LogEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    LogEvent.prototype.init = function (_data) {
        if (_data) {
            this.source = _data['Source'];
            this.timestamp = _data['Timestamp'];
            this.message = _data['Message'];
            this.eventType = _data['EventType'];
            this.durationNS = _data['DurationNS'];
        }
    };
    LogEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new LogEvent();
        result.init(data);
        return result;
    };
    LogEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Source'] = this.source;
        data['Timestamp'] = this.timestamp;
        data['Message'] = this.message;
        data['EventType'] = this.eventType;
        data['DurationNS'] = this.durationNS;
        return data;
    };
    return LogEvent;
}());
exports.LogEvent = LogEvent;
var Result = /** @class */ (function () {
    function Result(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    Result.prototype.init = function (_data) {
        if (_data) {
            this.stepRunID = _data['StepRunID'];
            this.status = _data['Status'];
            this.name = _data['Name'];
            this.rows = _data['Rows'];
            this.parent = _data['Parent'];
            if (Array.isArray(_data['Columns'])) {
                this.columns = [];
                for (var _i = 0, _a = _data['Columns']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.columns.push(ResultColumn.fromJS(item));
                }
            }
        }
    };
    Result.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new Result();
        result.init(data);
        return result;
    };
    Result.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StepRunID'] = this.stepRunID;
        data['Status'] = this.status;
        data['Name'] = this.name;
        data['Rows'] = this.rows;
        data['Parent'] = this.parent;
        if (Array.isArray(this.columns)) {
            data['Columns'] = [];
            for (var _i = 0, _a = this.columns; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Columns'].push(item.toJSON());
            }
        }
        return data;
    };
    return Result;
}());
exports.Result = Result;
var ResultColumn = /** @class */ (function () {
    function ResultColumn(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    ResultColumn.prototype.init = function (_data) {
        if (_data) {
            this.name = _data['Name'];
            this.objectType = _data['ObjectType'];
            if (Array.isArray(_data['Data'])) {
                this.data = [];
                for (var _i = 0, _a = _data['Data']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.data.push(item);
                }
            }
            this.typeCode = _data['TypeCode'];
        }
    };
    ResultColumn.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new ResultColumn();
        result.init(data);
        return result;
    };
    ResultColumn.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Name'] = this.name;
        data['ObjectType'] = this.objectType;
        if (Array.isArray(this.data)) {
            data['Data'] = [];
            for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Data'].push(item);
            }
        }
        data['TypeCode'] = this.typeCode;
        return data;
    };
    return ResultColumn;
}());
exports.ResultColumn = ResultColumn;
var SessionMetricKind;
(function (SessionMetricKind) {
    SessionMetricKind["Poll"] = "Poll";
    SessionMetricKind["Push"] = "Push";
    SessionMetricKind["PushPoll"] = "PushPoll";
})(SessionMetricKind = exports.SessionMetricKind || (exports.SessionMetricKind = {}));
var SessionMetricType;
(function (SessionMetricType) {
    SessionMetricType["Unknown"] = "Unknown";
    SessionMetricType["Double"] = "Double";
    SessionMetricType["Boolean"] = "Boolean";
    SessionMetricType["String"] = "String";
})(SessionMetricType = exports.SessionMetricType || (exports.SessionMetricType = {}));
var MetricsPollRate;
(function (MetricsPollRate) {
    MetricsPollRate["OneSecond"] = "OneSecond";
    MetricsPollRate["TwoSeconds"] = "TwoSeconds";
    MetricsPollRate["FiveSeconds"] = "FiveSeconds";
    MetricsPollRate["TenSeconds"] = "TenSeconds";
    MetricsPollRate["FifteenSeconds"] = "FifteenSeconds";
    MetricsPollRate["OneMinute"] = "OneMinute";
    MetricsPollRate["TwoMinutes"] = "TwoMinutes";
    MetricsPollRate["FiveMinutes"] = "FiveMinutes";
    MetricsPollRate["TenMinutes"] = "TenMinutes";
    MetricsPollRate["FifteenMinutes"] = "FifteenMinutes";
    MetricsPollRate["OneHour"] = "OneHour";
})(MetricsPollRate = exports.MetricsPollRate || (exports.MetricsPollRate = {}));
var SessionMetricInfo = /** @class */ (function () {
    function SessionMetricInfo(data) {
        this.attributes = [];
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    SessionMetricInfo.prototype.init = function (_data) {
        if (_data) {
            this.publish = _data['Publish'];
            this.kind = _data['Kind'];
            this.type = _data['Type'];
            this.groupName = _data['GroupName'];
            this.name = _data['Name'];
            this.metricFullName = _data['MetricFullName'];
            this.subjectPostfix = _data['SubjectPostfix'];
            if (Array.isArray(_data['Attributes']))
                this.attributes = _data['Attributes'];
        }
    };
    SessionMetricInfo.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionMetricInfo();
        result.init(data);
        return result;
    };
    SessionMetricInfo.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Publish'] = this.publish;
        data['Kind'] = this.kind;
        data['Type'] = this.type;
        data['GroupName'] = this.groupName;
        data['Name'] = this.name;
        data['MetricFullName'] = this.metricFullName;
        data['SubjectPostfix'] = this.subjectPostfix;
        data['Attributes'] = [];
        if (Array.isArray(this.attributes)) {
            data['Attributes'] = this.attributes;
        }
        return data;
    };
    return SessionMetricInfo;
}());
exports.SessionMetricInfo = SessionMetricInfo;
var MetricsConfiguration = /** @class */ (function () {
    function MetricsConfiguration(data) {
        this.metrics = [];
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    MetricsConfiguration.prototype.init = function (_data) {
        if (_data) {
            this.publishRate = _data['PublishRate'];
            if (Array.isArray(_data['Metrics']))
                this.metrics = _data['Metrics'].map(function (item) { return SessionMetricInfo.fromJS(item); });
        }
    };
    MetricsConfiguration.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MetricsConfiguration();
        result.init(data);
        return result;
    };
    MetricsConfiguration.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['PublishRate'] = this.publishRate;
        if (Array.isArray(this.metrics)) {
            data['Metrics'] = this.metrics.map(function (item) { return item.toJSON(); });
        }
        return data;
    };
    return MetricsConfiguration;
}());
exports.MetricsConfiguration = MetricsConfiguration;
var MetricValue = /** @class */ (function () {
    function MetricValue(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    MetricValue.prototype.init = function (_data) {
        if (_data) {
            this.time = _data['Time'];
            this.value = _data['Value'];
        }
    };
    MetricValue.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MetricValue();
        result.init(data);
        return result;
    };
    MetricValue.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Time'] = this.time;
        data['Value'] = this.value;
        return data;
    };
    return MetricValue;
}());
exports.MetricValue = MetricValue;
var SessionEvent = /** @class */ (function () {
    function SessionEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'SessionEvent';
    }
    SessionEvent.prototype.init = function (_data) {
        if (_data) {
            this.eventType = _data['EventType'];
            this.sessionId = _data['SessionId'];
        }
    };
    SessionEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['discriminator'] === 'SessionTimeoutEventArgs') {
            var result_28 = new SessionTimeoutEventArgs();
            result_28.init(data);
            return result_28;
        }
        if (data['discriminator'] === 'StartingEventArgs') {
            var result_29 = new StartingEventArgs();
            result_29.init(data);
            return result_29;
        }
        if (data['discriminator'] === 'StartedEventArgs') {
            var result_30 = new StartedEventArgs();
            result_30.init(data);
            return result_30;
        }
        if (data['discriminator'] === 'StoppingEventArgs') {
            var result_31 = new StoppingEventArgs();
            result_31.init(data);
            return result_31;
        }
        if (data['discriminator'] === 'StoppedEventArgs') {
            var result_32 = new StoppedEventArgs();
            result_32.init(data);
            return result_32;
        }
        if (data['discriminator'] === 'TestPlanChangeEventArgs') {
            var result_33 = new TestPlanChangeEventArgs();
            result_33.init(data);
            return result_33;
        }
        if (data['discriminator'] === 'TestPlanExecutionStateChangedEventArgs') {
            var result_34 = new TestPlanExecutionStateChangedEventArgs();
            result_34.init(data);
            return result_34;
        }
        if (data['discriminator'] === 'SettingsChangedEventArgs') {
            var result_35 = new SettingsChangedEventArgs();
            result_35.init(data);
            return result_35;
        }
        if (data['discriminator'] === 'TestStepChangeEventArgs') {
            var result_36 = new TestStepChangeEventArgs();
            result_36.init(data);
            return result_36;
        }
        if (data['discriminator'] === 'BreakEventArgs') {
            var result_37 = new BreakEventArgs();
            result_37.init(data);
            return result_37;
        }
        if (data['discriminator'] === 'UserInputRequestEventArgs') {
            var result_38 = new UserInputRequestEventArgs();
            result_38.init(data);
            return result_38;
        }
        if (data['discriminator'] === 'UserInputRequestCompletedEventArgs') {
            var result_39 = new UserInputRequestCompletedEventArgs();
            result_39.init(data);
            return result_39;
        }
        if (data['discriminator'] === 'TestPlanSettingsChangedEventArgs') {
            var result_40 = new TestPlanSettingsChangedEventArgs();
            result_40.init(data);
            return result_40;
        }
        var result = new SessionEvent();
        result.init(data);
        return result;
    };
    SessionEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['discriminator'] = this._discriminator;
        data['EventType'] = this.eventType;
        data['SessionId'] = this.sessionId;
        return data;
    };
    return SessionEvent;
}());
exports.SessionEvent = SessionEvent;
var SessionEventType;
(function (SessionEventType) {
    SessionEventType["SessionStarting"] = "SessionStarting";
    SessionEventType["SessionStarted"] = "SessionStarted";
    SessionEventType["SessionStopping"] = "SessionStopping";
    SessionEventType["SessionStopped"] = "SessionStopped";
    SessionEventType["TestPlanChanged"] = "TestPlanChanged";
    SessionEventType["TestPlanExecutionStateChanged"] = "TestPlanExecutionStateChanged";
    SessionEventType["SettingsChanged"] = "SettingsChanged";
    SessionEventType["TestStepChanged"] = "TestStepChanged";
    SessionEventType["BreakEvent"] = "BreakEvent";
    SessionEventType["UserInputRequested"] = "UserInputRequested";
    SessionEventType["UserInputCompleted"] = "UserInputCompleted";
    SessionEventType["SessionTimeoutHit"] = "SessionTimeoutHit";
    SessionEventType["TestPlanSettingsChanged"] = "TestPlanSettingsChanged";
    SessionEventType["TypeCacheInvalidated"] = "TypeCacheInvalidated";
    SessionEventType["Heartbeat"] = "Heartbeat";
    SessionEventType["MetricsConfigurationChanged"] = "MetricsConfigurationChanged";
})(SessionEventType = exports.SessionEventType || (exports.SessionEventType = {}));
var SessionTimeoutEventArgs = /** @class */ (function (_super) {
    __extends(SessionTimeoutEventArgs, _super);
    function SessionTimeoutEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SessionTimeoutEventArgs';
        return _this;
    }
    SessionTimeoutEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SessionTimeoutEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SessionTimeoutEventArgs();
        result.init(data);
        return result;
    };
    SessionTimeoutEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SessionTimeoutEventArgs;
}(SessionEvent));
exports.SessionTimeoutEventArgs = SessionTimeoutEventArgs;
var StartingEventArgs = /** @class */ (function (_super) {
    __extends(StartingEventArgs, _super);
    function StartingEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'StartingEventArgs';
        return _this;
    }
    StartingEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    StartingEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new StartingEventArgs();
        result.init(data);
        return result;
    };
    StartingEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return StartingEventArgs;
}(SessionEvent));
exports.StartingEventArgs = StartingEventArgs;
var StartedEventArgs = /** @class */ (function (_super) {
    __extends(StartedEventArgs, _super);
    function StartedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'StartedEventArgs';
        return _this;
    }
    StartedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    StartedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new StartedEventArgs();
        result.init(data);
        return result;
    };
    StartedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return StartedEventArgs;
}(SessionEvent));
exports.StartedEventArgs = StartedEventArgs;
var StoppingEventArgs = /** @class */ (function (_super) {
    __extends(StoppingEventArgs, _super);
    function StoppingEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'StoppingEventArgs';
        return _this;
    }
    StoppingEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    StoppingEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new StoppingEventArgs();
        result.init(data);
        return result;
    };
    StoppingEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return StoppingEventArgs;
}(SessionEvent));
exports.StoppingEventArgs = StoppingEventArgs;
var StoppedEventArgs = /** @class */ (function (_super) {
    __extends(StoppedEventArgs, _super);
    function StoppedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'StoppedEventArgs';
        return _this;
    }
    StoppedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    StoppedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new StoppedEventArgs();
        result.init(data);
        return result;
    };
    StoppedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return StoppedEventArgs;
}(SessionEvent));
exports.StoppedEventArgs = StoppedEventArgs;
var TestPlanChangeEventArgs = /** @class */ (function (_super) {
    __extends(TestPlanChangeEventArgs, _super);
    function TestPlanChangeEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestPlanChangeEventArgs';
        return _this;
    }
    TestPlanChangeEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestPlanChangeEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlanChangeEventArgs();
        result.init(data);
        return result;
    };
    TestPlanChangeEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestPlanChangeEventArgs;
}(SessionEvent));
exports.TestPlanChangeEventArgs = TestPlanChangeEventArgs;
var TestPlanExecutionStateChangedEventArgs = /** @class */ (function (_super) {
    __extends(TestPlanExecutionStateChangedEventArgs, _super);
    function TestPlanExecutionStateChangedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestPlanExecutionStateChangedEventArgs';
        return _this;
    }
    TestPlanExecutionStateChangedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.runStatus = _data['RunStatus'] ? RunStatus.fromJS(_data['RunStatus']) : undefined;
        }
    };
    TestPlanExecutionStateChangedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlanExecutionStateChangedEventArgs();
        result.init(data);
        return result;
    };
    TestPlanExecutionStateChangedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['RunStatus'] = this.runStatus ? this.runStatus.toJSON() : undefined;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestPlanExecutionStateChangedEventArgs;
}(SessionEvent));
exports.TestPlanExecutionStateChangedEventArgs = TestPlanExecutionStateChangedEventArgs;
var SettingsChangedEventArgs = /** @class */ (function (_super) {
    __extends(SettingsChangedEventArgs, _super);
    function SettingsChangedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'SettingsChangedEventArgs';
        return _this;
    }
    SettingsChangedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    SettingsChangedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new SettingsChangedEventArgs();
        result.init(data);
        return result;
    };
    SettingsChangedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return SettingsChangedEventArgs;
}(SessionEvent));
exports.SettingsChangedEventArgs = SettingsChangedEventArgs;
var TestStepChangeEventArgs = /** @class */ (function (_super) {
    __extends(TestStepChangeEventArgs, _super);
    function TestStepChangeEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestStepChangeEventArgs';
        return _this;
    }
    TestStepChangeEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.stepId = _data['StepId'];
        }
    };
    TestStepChangeEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepChangeEventArgs();
        result.init(data);
        return result;
    };
    TestStepChangeEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StepId'] = this.stepId;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestStepChangeEventArgs;
}(SessionEvent));
exports.TestStepChangeEventArgs = TestStepChangeEventArgs;
var BreakEventArgs = /** @class */ (function (_super) {
    __extends(BreakEventArgs, _super);
    function BreakEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'BreakEventArgs';
        return _this;
    }
    BreakEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.stepId = _data['StepId'];
        }
    };
    BreakEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new BreakEventArgs();
        result.init(data);
        return result;
    };
    BreakEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['StepId'] = this.stepId;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return BreakEventArgs;
}(SessionEvent));
exports.BreakEventArgs = BreakEventArgs;
var UserInputRequestEventArgs = /** @class */ (function (_super) {
    __extends(UserInputRequestEventArgs, _super);
    function UserInputRequestEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'UserInputRequestEventArgs';
        return _this;
    }
    UserInputRequestEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.requestId = _data['RequestId'];
        }
    };
    UserInputRequestEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new UserInputRequestEventArgs();
        result.init(data);
        return result;
    };
    UserInputRequestEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['RequestId'] = this.requestId;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return UserInputRequestEventArgs;
}(SessionEvent));
exports.UserInputRequestEventArgs = UserInputRequestEventArgs;
var UserInputRequestCompletedEventArgs = /** @class */ (function (_super) {
    __extends(UserInputRequestCompletedEventArgs, _super);
    function UserInputRequestCompletedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'UserInputRequestCompletedEventArgs';
        return _this;
    }
    UserInputRequestCompletedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.requestId = _data['RequestId'];
            this.answered = _data['Answered'];
            this.timeout = _data['Timeout'];
        }
    };
    UserInputRequestCompletedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new UserInputRequestCompletedEventArgs();
        result.init(data);
        return result;
    };
    UserInputRequestCompletedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['RequestId'] = this.requestId;
        data['Answered'] = this.answered;
        data['Timeout'] = this.timeout;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return UserInputRequestCompletedEventArgs;
}(SessionEvent));
exports.UserInputRequestCompletedEventArgs = UserInputRequestCompletedEventArgs;
var TestPlanSettingsChangedEventArgs = /** @class */ (function (_super) {
    __extends(TestPlanSettingsChangedEventArgs, _super);
    function TestPlanSettingsChangedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestPlanSettingsChangedEventArgs';
        return _this;
    }
    TestPlanSettingsChangedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestPlanSettingsChangedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlanSettingsChangedEventArgs();
        result.init(data);
        return result;
    };
    TestPlanSettingsChangedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestPlanSettingsChangedEventArgs;
}(SessionEvent));
exports.TestPlanSettingsChangedEventArgs = TestPlanSettingsChangedEventArgs;
var HeartbeatEventArgs = /** @class */ (function (_super) {
    __extends(HeartbeatEventArgs, _super);
    function HeartbeatEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'HeartbeatEventArgs';
        return _this;
    }
    HeartbeatEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    HeartbeatEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new HeartbeatEventArgs();
        result.init(data);
        return result;
    };
    HeartbeatEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return HeartbeatEventArgs;
}(SessionEvent));
exports.HeartbeatEventArgs = HeartbeatEventArgs;
var MetricsConfigurationChangedEventArgs = /** @class */ (function (_super) {
    __extends(MetricsConfigurationChangedEventArgs, _super);
    function MetricsConfigurationChangedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'MetricsConfigurationChangedEventArgs';
        return _this;
    }
    MetricsConfigurationChangedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    MetricsConfigurationChangedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MetricsConfigurationChangedEventArgs();
        result.init(data);
        return result;
    };
    MetricsConfigurationChangedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return MetricsConfigurationChangedEventArgs;
}(SessionEvent));
exports.MetricsConfigurationChangedEventArgs = MetricsConfigurationChangedEventArgs;
var OnTestPlanRun = /** @class */ (function () {
    function OnTestPlanRun(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    OnTestPlanRun.prototype.init = function (_data) {
        if (_data) {
            this.status = _data['Status'];
            this.userId = _data['UserId'];
        }
    };
    OnTestPlanRun.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new OnTestPlanRun();
        result.init(data);
        return result;
    };
    OnTestPlanRun.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Status'] = this.status;
        data['UserId'] = this.userId;
        return data;
    };
    return OnTestPlanRun;
}());
exports.OnTestPlanRun = OnTestPlanRun;
var OnTestStepRun = /** @class */ (function () {
    function OnTestStepRun(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    OnTestStepRun.prototype.init = function (_data) {
        if (_data) {
            this.status = _data['Status'];
            this.stepId = _data['StepId'];
            this.parentRunId = _data['ParentRunId'];
            this.verdict = _data['Verdict'];
            this.duration = _data['Duration'];
        }
    };
    OnTestStepRun.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new OnTestStepRun();
        result.init(data);
        return result;
    };
    OnTestStepRun.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Status'] = this.status;
        data['StepId'] = this.stepId;
        data['ParentRunId'] = this.parentRunId;
        data['Verdict'] = this.verdict;
        data['Duration'] = this.duration;
        return data;
    };
    return OnTestStepRun;
}());
exports.OnTestStepRun = OnTestStepRun;
var TestStepRunEvent = /** @class */ (function () {
    function TestStepRunEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'TestStepRunEvent';
    }
    TestStepRunEvent.prototype.init = function (_data) {
        if (_data) {
            this.parent = _data['Parent'];
            this.testStepId = _data['TestStepId'];
            this.testStepName = _data['TestStepName'];
            this.testStepTypeName = _data['TestStepTypeName'];
            this.id = _data['Id'];
            this.verdict = _data['Verdict'];
            this.startTime = _data['StartTime'];
            if (Array.isArray(_data['Parameters'])) {
                this.parameters = [];
                for (var _i = 0, _a = _data['Parameters']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.parameters.push(Parameter.fromJS(item));
                }
            }
        }
    };
    TestStepRunEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['discriminator'] === 'TestStepRunStartEventArgs') {
            var result_41 = new TestStepRunStartEventArgs();
            result_41.init(data);
            return result_41;
        }
        if (data['discriminator'] === 'TestStepRunCompletedEventArgs') {
            var result_42 = new TestStepRunCompletedEventArgs();
            result_42.init(data);
            return result_42;
        }
        var result = new TestStepRunEvent();
        result.init(data);
        return result;
    };
    TestStepRunEvent.prototype.toJSON = function (data) {
        data['Parent'] = this.parent;
        data['TestStepId'] = this.testStepId;
        data['TestStepName'] = this.testStepName;
        data['TestStepTypeName'] = this.testStepTypeName;
        data['Id'] = this.id;
        data['Verdict'] = this.verdict;
        data['StartTime'] = this.startTime;
        if (Array.isArray(this.parameters)) {
            data['Parameters'] = [];
            for (var _i = 0, _a = this.parameters; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Parameters'].push(item.toJSON());
            }
        }
        return data;
    };
    return TestStepRunEvent;
}());
exports.TestStepRunEvent = TestStepRunEvent;
var TestStepRunStartEventArgs = /** @class */ (function (_super) {
    __extends(TestStepRunStartEventArgs, _super);
    function TestStepRunStartEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestStepRunStartEventArgs';
        return _this;
    }
    TestStepRunStartEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestStepRunStartEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepRunStartEventArgs();
        result.init(data);
        return result;
    };
    TestStepRunStartEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestStepRunStartEventArgs;
}(TestStepRunEvent));
exports.TestStepRunStartEventArgs = TestStepRunStartEventArgs;
var TestStepRunCompletedEventArgs = /** @class */ (function (_super) {
    __extends(TestStepRunCompletedEventArgs, _super);
    function TestStepRunCompletedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestStepRunCompletedEventArgs';
        return _this;
    }
    TestStepRunCompletedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestStepRunCompletedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestStepRunCompletedEventArgs();
        result.init(data);
        return result;
    };
    TestStepRunCompletedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestStepRunCompletedEventArgs;
}(TestStepRunEvent));
exports.TestStepRunCompletedEventArgs = TestStepRunCompletedEventArgs;
var TestPlanRunEvent = /** @class */ (function () {
    function TestPlanRunEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this._discriminator = 'TestPlanRunEvent';
    }
    TestPlanRunEvent.prototype.init = function (_data) {
        if (_data) {
            this.testPlanRunId = _data['Run/TestPlanRunId'];
            this.testPlanRunGuid = _data['Run/TestPlanRunGuid'];
            this.path = _data['Run/Path'];
            this.name = _data['Run/Name'];
            this.verdict = _data['Run/Verdict'];
            this.startTime = _data['Run/StartTime'];
            this.runner = _data['Run/Runner'];
            this.status = _data['Run/Status'];
            this.isCampaign = _data['Run/IsCampaign'];
            this.operator = _data['Run/Operator'];
        }
    };
    TestPlanRunEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['discriminator'] === 'TestPlanRunStartEventArgs') {
            var result_43 = new TestPlanRunStartEventArgs();
            result_43.init(data);
            return result_43;
        }
        if (data['discriminator'] === 'TestPlanRunCompletedEventArgs') {
            var result_44 = new TestPlanRunCompletedEventArgs();
            result_44.init(data);
            return result_44;
        }
        var result = new TestPlanRunEvent();
        result.init(data);
        return result;
    };
    TestPlanRunEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Run/TestPlanRunId'] = this.testPlanRunId;
        data['Run/TestPlanRunGuid'] = this.testPlanRunGuid;
        data['Run/Path'] = this.path;
        data['Run/Name'] = this.name;
        data['Run/Verdict'] = this.verdict;
        data['Run/StartTime'] = this.startTime;
        data['Run/Runner'] = this.runner;
        data['Run/Status'] = this.status;
        data['Run/IsCampaign'] = this.isCampaign;
        data['Run/Operator'] = this.operator;
        return data;
    };
    return TestPlanRunEvent;
}());
exports.TestPlanRunEvent = TestPlanRunEvent;
var TestPlanRunStartEventArgs = /** @class */ (function (_super) {
    __extends(TestPlanRunStartEventArgs, _super);
    function TestPlanRunStartEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestPlanRunStartEventArgs';
        return _this;
    }
    TestPlanRunStartEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    TestPlanRunStartEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlanRunStartEventArgs();
        result.init(data);
        return result;
    };
    TestPlanRunStartEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestPlanRunStartEventArgs;
}(TestPlanRunEvent));
exports.TestPlanRunStartEventArgs = TestPlanRunStartEventArgs;
var TestPlanRunCompletedEventArgs = /** @class */ (function (_super) {
    __extends(TestPlanRunCompletedEventArgs, _super);
    function TestPlanRunCompletedEventArgs(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'TestPlanRunCompletedEventArgs';
        return _this;
    }
    TestPlanRunCompletedEventArgs.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            this.durationInSeconds = _data['Run/DurationInSeconds'];
        }
    };
    TestPlanRunCompletedEventArgs.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new TestPlanRunCompletedEventArgs();
        result.init(data);
        return result;
    };
    TestPlanRunCompletedEventArgs.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['Run/DurationInSeconds'] = this.durationInSeconds;
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return TestPlanRunCompletedEventArgs;
}(TestPlanRunEvent));
exports.TestPlanRunCompletedEventArgs = TestPlanRunCompletedEventArgs;
var RunnerEvent = /** @class */ (function () {
    function RunnerEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
        this.type = 'RunnerEvent';
    }
    RunnerEvent.prototype.init = function (_data) {
        if (_data) {
            this.runnerId = _data['RunnerId'];
        }
    };
    RunnerEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        if (data['type'] === 'RunnerRegisteredEvent') {
            var result_45 = new RunnerRegisteredEvent();
            result_45.init(data);
            return result_45;
        }
        if (data['type'] === 'RunnerUpdatedEvent') {
            var result_46 = new RunnerUpdatedEvent();
            result_46.init(data);
            return result_46;
        }
        if (data['type'] === 'RunnerDeletedEvent') {
            var result_47 = new RunnerDeletedEvent();
            result_47.init(data);
            return result_47;
        }
        var result = new RunnerEvent();
        result.init(data);
        return result;
    };
    RunnerEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['RunnerId'] = this.runnerId;
        return data;
    };
    return RunnerEvent;
}());
exports.RunnerEvent = RunnerEvent;
var RunnerRegisteredEvent = /** @class */ (function (_super) {
    __extends(RunnerRegisteredEvent, _super);
    function RunnerRegisteredEvent(data) {
        var _this = _super.call(this, data) || this;
        _this.type = 'RunnerRegisteredEvent';
        return _this;
    }
    RunnerRegisteredEvent.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    RunnerRegisteredEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RunnerRegisteredEvent();
        result.init(data);
        return result;
    };
    RunnerRegisteredEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return RunnerRegisteredEvent;
}(RunnerEvent));
exports.RunnerRegisteredEvent = RunnerRegisteredEvent;
var RunnerUpdatedEvent = /** @class */ (function (_super) {
    __extends(RunnerUpdatedEvent, _super);
    function RunnerUpdatedEvent(data) {
        var _this = _super.call(this, data) || this;
        _this.type = 'RunnerUpdatedEvent';
        return _this;
    }
    RunnerUpdatedEvent.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    RunnerUpdatedEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RunnerUpdatedEvent();
        result.init(data);
        return result;
    };
    RunnerUpdatedEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return RunnerUpdatedEvent;
}(RunnerEvent));
exports.RunnerUpdatedEvent = RunnerUpdatedEvent;
var RunnerDeletedEvent = /** @class */ (function (_super) {
    __extends(RunnerDeletedEvent, _super);
    function RunnerDeletedEvent(data) {
        var _this = _super.call(this, data) || this;
        _this.type = 'RunnerDeletedEvent';
        return _this;
    }
    RunnerDeletedEvent.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
    };
    RunnerDeletedEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new RunnerDeletedEvent();
        result.init(data);
        return result;
    };
    RunnerDeletedEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return RunnerDeletedEvent;
}(RunnerEvent));
exports.RunnerDeletedEvent = RunnerDeletedEvent;
var MetadataUpdatedEvent = /** @class */ (function () {
    function MetadataUpdatedEvent(data) {
        if (data) {
            for (var property in data) {
                if (Object.prototype.hasOwnProperty.call(data, property))
                    this[property] = data[property];
            }
        }
    }
    MetadataUpdatedEvent.prototype.init = function (_data) {
        if (_data) {
            this.sessionId = _data['SessionId'];
            this.metadata = _data['Metadata'];
        }
    };
    MetadataUpdatedEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new MetadataUpdatedEvent();
        result.init(data);
        return result;
    };
    MetadataUpdatedEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        data['SessionId'] = this.sessionId;
        data['Metadata'] = this.metadata;
        return data;
    };
    return MetadataUpdatedEvent;
}());
exports.MetadataUpdatedEvent = MetadataUpdatedEvent;
var AssetUpdatedEvent = /** @class */ (function (_super) {
    __extends(AssetUpdatedEvent, _super);
    function AssetUpdatedEvent(data) {
        var _this = _super.call(this, data) || this;
        _this._discriminator = 'AssetUpdatedEvent';
        return _this;
    }
    AssetUpdatedEvent.prototype.init = function (_data) {
        _super.prototype.init.call(this, _data);
        if (_data) {
            if (Array.isArray(_data['Assets'])) {
                this.assets = [];
                for (var _i = 0, _a = _data['Assets']; _i < _a.length; _i++) {
                    var item = _a[_i];
                    this.assets.push(item);
                }
            }
        }
    };
    AssetUpdatedEvent.fromJS = function (data) {
        data = typeof data === 'object' ? data : {};
        var result = new AssetUpdatedEvent();
        result.init(data);
        return result;
    };
    AssetUpdatedEvent.prototype.toJSON = function (data) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.assets)) {
            data['Assets'] = [];
            for (var _i = 0, _a = this.assets; _i < _a.length; _i++) {
                var item = _a[_i];
                data['Assets'].push(item);
            }
        }
        _super.prototype.toJSON.call(this, data);
        return data;
    };
    return AssetUpdatedEvent;
}(RunnerEvent));
exports.AssetUpdatedEvent = AssetUpdatedEvent;
