"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanCodec = exports.NumberCodec = exports.jsonCodec = exports.stringCodec = exports.booleanCodec = exports.numberCodec = void 0;
var nats_ws_1 = require("nats.ws");
exports.numberCodec = NumberCodec();
exports.booleanCodec = BooleanCodec();
exports.stringCodec = (0, nats_ws_1.StringCodec)();
exports.jsonCodec = (0, nats_ws_1.JSONCodec)();
function NumberCodec() {
    return {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        encode: function (d) {
            throw new Error('not implemented');
        },
        decode: function (a) {
            var dataView = new DataView(a.buffer);
            return dataView.getFloat64(a.byteOffset, true); // BitConverter.ToDouble in C# is little-endian
        },
    };
}
exports.NumberCodec = NumberCodec;
function BooleanCodec() {
    return {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        encode: function (d) {
            throw new Error('not implemented');
        },
        decode: function (a) {
            return a[0] === 1;
        },
    };
}
exports.BooleanCodec = BooleanCodec;
