import { CommonContext, ComponentSettingsBase, ComponentSettingsListItem, DataGridControl, Image, RepositoryPackageReference, Setting } from './DTOs';
export interface DefaultSessionRequest {
    imageOverride: Image | null;
    testPlanReference: RepositoryPackageReference | null;
}
export interface SetSettingsRequest {
    contextId: string;
    settings: Setting[];
}
export interface PropertyReferenceRequest {
    contextId: string;
    propertyName: string | null;
}
export interface SetContextMenuRequest {
    contextId: string;
    propertyName: string | null;
    contextMenu: Setting[];
}
export interface SetDataGridRequest {
    contextId: string;
    propertyName: string;
    dataGridControl: DataGridControl;
}
export interface AddDataGridItemTypeRequest {
    contextId: string;
    propertyName: string | null;
    typeName: string | null;
}
export interface CommonStepSettingsContextRequest {
    commonContext: CommonContext;
    propertyName: string | null;
}
export interface GetSessionLogsRequest {
    id: string | undefined;
    levels: number[] | undefined;
    excludedSources: string[] | undefined;
    filterText: string | undefined;
    offset: number | undefined;
    limit: number | undefined;
}
export interface GetSessionSearchRequest {
    id: string | undefined;
    levels: number[] | null | undefined;
    excludedSources: string[] | null | undefined;
    filterText: string | null | undefined;
    searchText: string | null | undefined;
}
export interface GetComponentSettingsRequest {
    groupName: string | undefined;
    name: string | undefined;
}
export interface SetComponentSettingsRequest extends GetComponentSettingsRequest {
    returnedSettings: ComponentSettingsBase | undefined;
}
export interface GetComponentSettingsListItemRequest extends GetComponentSettingsRequest {
    index: number | undefined;
}
export interface SetComponentSettingsListItemRequest extends GetComponentSettingsListItemRequest {
    item: ComponentSettingsListItem | undefined;
}
export interface GetComponentSettingDataGridRequest extends GetComponentSettingsListItemRequest {
    propertyName: string | undefined;
}
export interface SetComponentSettingDataGridRequest extends GetComponentSettingDataGridRequest {
    dataGridControl: DataGridControl | undefined;
}
export interface AddComponentSettingDataGridItemTypeRequest extends GetComponentSettingDataGridRequest {
    typeName: string | undefined;
}
export interface AddComponentSettingsListItemRequest extends GetComponentSettingsRequest {
    typeName: string | undefined;
}
export interface DownloadTapSettingsRequest {
    groupName: string | undefined;
}
export interface RunnerUpdateRequest {
    updateTo: string;
}
