/// <reference types="node" />
export declare class Image implements IImage {
    name?: string | undefined;
    packages?: PackageSpecifier[];
    repositories?: string[];
    id?: string | undefined;
    constructor(data?: IImage);
    init(_data?: any): void;
    static fromJS(data: any): Image;
    toJSON(data?: any): any;
}
export interface IImage {
    name?: string | undefined;
    packages?: PackageSpecifier[] | undefined;
    repositories?: string[] | undefined;
    id?: string | undefined;
}
export declare class PackageSpecifier implements IPackageSpecifier {
    name?: string | undefined;
    version?: string | undefined;
    architecture?: string | undefined;
    oS?: string | undefined;
    constructor(data?: IPackageSpecifier);
    init(_data?: any): void;
    static fromJS(data: any): PackageSpecifier;
    toJSON(data?: any): any;
}
export interface IPackageSpecifier {
    name?: string | undefined;
    version?: string | undefined;
    architecture?: string | undefined;
    oS?: string | undefined;
}
export declare class ErrorResponse implements IErrorResponse {
    type?: string | undefined;
    message?: string | undefined;
    parameter?: string | undefined;
    source?: string | undefined;
    stackTrace?: string | undefined;
    inner?: ErrorResponse | undefined;
    subject?: string | undefined;
    constructor(data?: IErrorResponse);
    init(_data?: any): void;
    static fromJS(data: any): ErrorResponse;
    toJSON(data?: any): any;
}
export interface IErrorResponse {
    type?: string | undefined;
    message?: string | undefined;
    parameter?: string | undefined;
    source?: string | undefined;
    stackTrace?: string | undefined;
    inner?: ErrorResponse | undefined;
}
export declare class NoResponderError extends ErrorResponse {
    constructor();
    static fromJS(): NoResponderError;
}
export declare class ImageResolveErrorResponse extends ErrorResponse implements IImageResolveErrorResponse {
    dotGraph?: string | undefined;
    constructor(data?: IImageResolveErrorResponse);
    init(_data?: any): void;
    static fromJS(data: any): ImageResolveErrorResponse;
    toJSON(data?: any): any;
}
export interface IImageResolveErrorResponse extends IErrorResponse {
    dotGraph?: string | undefined;
}
export declare class Session implements ISession {
    subject?: string | undefined;
    id?: string | undefined;
    imageId?: string | undefined;
    executionState?: ExecutionState;
    testPlanRunId?: string | undefined;
    startedBy?: string | undefined;
    metadata?: {
        [key: string]: string;
    } | undefined;
    constructor(data?: ISession);
    init(_data?: any): void;
    static fromJS(data: any): Session;
    toJSON(data?: any): any;
}
export interface ISession {
    subject?: string | undefined;
    id?: string | undefined;
    imageId?: string | undefined;
    executionState?: ExecutionState;
    testPlanRunId?: string | undefined;
    startedBy?: string | undefined;
    metadata?: {
        [key: string]: string;
    } | undefined;
}
export declare class Links implements ILinks {
    editor?: string | undefined;
    constructor(data?: ILinks);
    init(_data?: any): void;
    static fromJS(data: any): Links;
    toJSON(data?: any): any;
}
export interface ILinks {
    editor?: string | undefined;
}
export declare abstract class ComponentSettingsBase implements IComponentSettingsBase {
    name?: string | undefined;
    groupName?: string | undefined;
    protected _discriminator: string;
    constructor(data?: IComponentSettingsBase);
    init(_data?: any): void;
    static fromJS(data: any): ComponentSettingsBase;
    toJSON(data?: any): any;
}
export interface IComponentSettingsBase {
    name?: string | undefined;
    groupName?: string | undefined;
}
export declare class ComponentSettingsIdentifier extends ComponentSettingsBase implements IComponentSettingsBase {
    constructor(data?: IComponentSettingsBase);
    init(_data?: any): void;
    static fromJS(data: any): ComponentSettingsIdentifier;
    toJSON(data?: any): any;
}
/** The supported layout modes. */
export declare enum DisplayMode {
    MasterDetail = "MasterDetail",
    DataGrid = "DataGrid"
}
export declare class ComponentSettingsList extends ComponentSettingsBase implements IComponentSettingsList {
    items?: ComponentSettingsListItem[] | undefined;
    displayMode?: DisplayMode | undefined;
    itemType?: string | undefined;
    itemTypeDisplayName?: string | undefined;
    constructor(data?: IComponentSettingsList);
    init(_data?: any): void;
    static fromJS(data: any): ComponentSettingsList;
    toJSON(data?: any): any;
}
export interface IComponentSettingsList extends IComponentSettingsBase {
    items?: ComponentSettingsListItem[] | undefined;
    displayMode?: DisplayMode | undefined;
    itemType?: string | undefined;
    itemTypeDisplayName?: string | undefined;
}
export declare abstract class AnnotatedObject implements IAnnotatedObject {
    visualStatus?: VisualStatus | undefined;
    valueType?: string | undefined;
    display?: DisplayAttribute | undefined;
    metaData?: MetaData | undefined;
    externalParameter?: ExternalParameter | undefined;
    unitAttribute?: UnitAttribute | undefined;
    constructor(data?: IAnnotatedObject);
    init(_data?: any): void;
    static fromJS(data: any): AnnotatedObject;
    toJSON(data?: any): any;
}
export interface IAnnotatedObject {
    visualStatus?: VisualStatus | undefined;
    valueType?: string | undefined;
    display?: DisplayAttribute | undefined;
    metaData?: MetaData | undefined;
    externalParameter?: ExternalParameter | undefined;
    unitAttribute?: UnitAttribute | undefined;
}
export declare class ComponentSettingsListItem extends AnnotatedObject implements IComponentSettingsListItem {
    settings?: Setting[] | undefined;
    name?: string | undefined;
    enabledResource?: boolean | undefined;
    constructor(data?: IComponentSettingsListItem);
    init(_data?: any): void;
    static fromJS(data: any): ComponentSettingsListItem;
    toJSON(data?: any): any;
}
export interface IComponentSettingsListItem extends IAnnotatedObject {
    settings?: Setting[] | undefined;
    name?: string | undefined;
    enabledResource?: boolean | undefined;
}
export declare class Setting extends AnnotatedObject implements ISetting {
    errors?: string[] | undefined;
    layout?: Layout | undefined;
    columnDisplayName?: ColumnDisplayName | undefined;
    valueDescription?: string | undefined;
    propertyName?: string | undefined;
    icons?: Icon[] | undefined;
    submit?: boolean | undefined;
    protected _discriminator: string;
    constructor(data?: ISetting);
    init(_data?: any): void;
    static fromJS(data: any): Setting;
    toJSON(data?: any): any;
}
export interface ISetting extends IAnnotatedObject {
    errors?: string[] | undefined;
    layout?: Layout | undefined;
    columnDisplayName?: ColumnDisplayName | undefined;
    valueDescription?: string | undefined;
    propertyName?: string | undefined;
    icons?: Icon[] | undefined;
    submit?: boolean | undefined;
}
export declare class Layout implements ILayout {
    mode?: LayoutMode;
    rowHeight?: number;
    maxRowHeight?: number;
    constructor(data?: ILayout);
    init(_data?: any): void;
    static fromJS(data: any): Layout;
    toJSON(data?: any): any;
}
export interface ILayout {
    mode?: LayoutMode;
    rowHeight?: number;
    maxRowHeight?: number;
}
/** The supported layout modes. */
export declare enum LayoutMode {
    Normal = "Normal",
    FullRow = "FullRow",
    FloatBottom = "FloatBottom"
}
export declare class ColumnDisplayName implements IColumnDisplayName {
    columnName?: string | undefined;
    order?: number;
    isReadOnly?: boolean;
    constructor(data?: IColumnDisplayName);
    init(_data?: any): void;
    static fromJS(data: any): ColumnDisplayName;
    toJSON(data?: any): any;
}
export interface IColumnDisplayName {
    columnName?: string | undefined;
    order?: number;
    isReadOnly?: boolean;
}
export declare class Icon implements IIcon {
    iconName?: string | undefined;
    invoke?: boolean | undefined;
    stepReference?: string | undefined;
    propertyReference?: string | undefined;
    constructor(data?: IIcon);
    init(_data?: any): void;
    static fromJS(data: any): Icon;
    toJSON(data?: any): any;
}
export interface IUnitAttribute {
    unit: string | undefined;
    preScaling: number | undefined;
    stringFormat: string | undefined;
    useRanges: boolean | undefined;
    useEngineeringPrefix: boolean | undefined;
}
export declare class UnitAttribute implements IUnitAttribute {
    unit: string | undefined;
    preScaling: number | undefined;
    stringFormat: string | undefined;
    useRanges: boolean | undefined;
    useEngineeringPrefix: boolean | undefined;
    constructor(data?: IUnitAttribute);
    init(_data?: any): void;
    static fromJS(data: any): UnitAttribute;
    toJSON(data?: any): any;
}
export interface IIcon {
    iconName?: string | undefined;
    invoke?: boolean | undefined;
    stepReference?: string | undefined;
    propertyReference?: string | undefined;
}
export declare class VisualStatus implements IVisualStatus {
    isReadOnly?: boolean;
    isVisible?: boolean;
    isEnabled?: boolean;
    constructor(data?: IVisualStatus);
    init(_data?: any): void;
    static fromJS(data: any): VisualStatus;
    toJSON(data?: any): any;
}
export interface IVisualStatus {
    isReadOnly?: boolean;
    isVisible?: boolean;
    isEnabled?: boolean;
}
export declare class DisplayAttribute implements IDisplayAttribute {
    description?: string | undefined;
    group?: string[] | undefined;
    name?: string | undefined;
    order?: number;
    collapsed?: boolean;
    constructor(data?: IDisplayAttribute);
    init(_data?: any): void;
    static fromJS(data: any): DisplayAttribute;
    toJSON(data?: any): any;
}
export interface IDisplayAttribute {
    description?: string | undefined;
    group?: string[] | undefined;
    name?: string | undefined;
    order?: number;
    collapsed?: boolean;
}
export declare class MetaData implements IMetaData {
    name?: string | undefined;
    macroName?: string | undefined;
    group?: string | undefined;
    frozen?: boolean;
    constructor(data?: IMetaData);
    init(_data?: any): void;
    static fromJS(data: any): MetaData;
    toJSON(data?: any): any;
}
export interface IMetaData {
    name?: string | undefined;
    macroName?: string | undefined;
    group?: string | undefined;
    frozen?: boolean;
}
export declare class ExternalParameter implements IExternalParameter {
    name?: string | undefined;
    constructor(data?: IExternalParameter);
    init(_data?: any): void;
    static fromJS(data: any): ExternalParameter;
    toJSON(data?: any): any;
}
export interface IExternalParameter {
    name?: string | undefined;
}
export declare class ButtonControl extends Setting implements IButtonControl {
    invokeMethod?: boolean;
    constructor(data?: IButtonControl);
    init(_data?: any): void;
    static fromJS(data: any): ButtonControl;
    toJSON(data?: any): any;
}
export interface IButtonControl extends ISetting {
    invokeMethod?: boolean;
}
export declare class ButtonsControl extends Setting implements IButtonsControl {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number;
    invokeMethod?: boolean;
    constructor(data?: IButtonsControl);
    init(_data?: any): void;
    static fromJS(data: any): ButtonsControl;
    toJSON(data?: any): any;
}
export interface IButtonsControl extends ISetting {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number;
    invokeMethod?: boolean;
}
export declare class AvailableValue implements IAvailableValue {
    name?: string | undefined;
    description?: string | undefined;
    constructor(data?: IAvailableValue);
    init(_data?: any): void;
    static fromJS(data: any): AvailableValue;
    toJSON(data?: any): any;
}
export interface IAvailableValue {
    name?: string | undefined;
    description?: string | undefined;
}
export declare class CheckBoxControl extends Setting implements ICheckBoxControl {
    boolValue?: boolean | undefined;
    constructor(data?: ICheckBoxControl);
    init(_data?: any): void;
    static fromJS(data: any): CheckBoxControl;
    toJSON(data?: any): any;
}
export interface ICheckBoxControl extends ISetting {
    boolValue?: boolean | undefined;
}
export declare class DataGridReferenceControl extends Setting implements IDataGridReferenceControl {
    constructor(data?: IDataGridReferenceControl);
    init(_data?: any): void;
    static fromJS(data: any): DataGridReferenceControl;
    toJSON(data?: any): any;
}
export declare type IDataGridReferenceControl = ISetting;
export declare class DataGridControl extends Setting implements IDataGridControl {
    items?: Setting[][] | undefined;
    fixedSize?: boolean;
    constructor(data?: IDataGridControl);
    init(_data?: any): void;
    static fromJS(data: any): DataGridControl;
    toJSON(data?: any): any;
}
export interface IDataGridControl extends ISetting {
    items?: Setting[][] | undefined;
    fixedSize?: boolean;
}
export declare class TextBoxControl extends Setting implements ITextBoxControl {
    stringValue?: string | undefined;
    constructor(data?: ITextBoxControl);
    init(_data?: any): void;
    static fromJS(data: any): TextBoxControl;
    toJSON(data?: any): any;
}
export interface ITextBoxControl extends ISetting {
    stringValue?: string | undefined;
}
export declare class ComboBoxControl extends TextBoxControl implements IComboBoxControl {
    suggestedValues?: string[] | undefined;
    constructor(data?: IComboBoxControl);
    init(_data?: any): void;
    static fromJS(data: any): ComboBoxControl;
    toJSON(data?: any): any;
}
export interface IComboBoxControl extends ITextBoxControl {
    suggestedValues?: string[] | undefined;
}
export declare class FilePathControl extends Setting implements IFilePathControl {
    stringValue?: string | undefined;
    fileExtension?: string | undefined;
    constructor(data?: IFilePathControl);
    init(_data?: any): void;
    static fromJS(data: any): FilePathControl;
    toJSON(data?: any): any;
}
export interface IFilePathControl extends ISetting {
    stringValue?: string | undefined;
    fileExtension?: string | undefined;
}
export declare class DirectoryPathControl extends Setting implements IDirectoryPathControl {
    stringValue?: string | undefined;
    constructor(data?: IDirectoryPathControl);
    init(_data?: any): void;
    static fromJS(data: any): DirectoryPathControl;
    toJSON(data?: any): any;
}
export interface IDirectoryPathControl extends ISetting {
    stringValue?: string | undefined;
}
export declare class EnabledControl extends Setting implements IEnabledControl {
    isEnabled?: boolean | undefined;
    value?: Setting | undefined;
    constructor(data?: IEnabledControl);
    init(_data?: any): void;
    static fromJS(data: any): EnabledControl;
    toJSON(data?: any): any;
}
export interface IEnabledControl extends ISetting {
    isEnabled?: boolean | undefined;
    value?: Setting | undefined;
}
export declare class DropdownControl extends Setting implements IDropdownControl {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number;
    constructor(data?: IDropdownControl);
    init(_data?: any): void;
    static fromJS(data: any): DropdownControl;
    toJSON(data?: any): any;
}
export interface IDropdownControl extends ISetting {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number;
}
export declare class MultiSelectControl extends Setting implements IMultiSelectControl {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number[] | undefined;
    constructor(data?: IMultiSelectControl);
    init(_data?: any): void;
    static fromJS(data: any): MultiSelectControl;
    toJSON(data?: any): any;
}
export interface IMultiSelectControl extends ISetting {
    availableValues?: AvailableValue[] | undefined;
    selectedIndex?: number[] | undefined;
}
export declare class PasswordControl extends Setting implements IPasswordControl {
    password?: string | undefined;
    constructor(data?: IPasswordControl);
    init(_data?: any): void;
    static fromJS(data: any): PasswordControl;
    toJSON(data?: any): any;
}
export interface IPasswordControl extends ISetting {
    password?: string | undefined;
}
export declare class PictureControl extends Setting implements IPictureControl {
    description?: string | undefined;
    mimeType?: string | undefined;
    resource?: Resource | undefined;
    constructor(data?: IPictureControl);
    init(_data?: any): void;
    static fromJS(data: any): PictureControl;
    toJSON(data?: any): any;
}
export interface IPictureControl extends ISetting {
    description?: string | undefined;
    mimeType?: string | undefined;
    resource?: Resource | undefined;
}
export declare class PluginTypeSelectorControl extends Setting implements IPluginTypeSelectorControl {
    availableValues: AvailableValue[];
    selectedIndex?: number;
    constructor(data?: IPluginTypeSelectorControl);
    init(_data?: any): void;
    static fromJS(data: any): PluginTypeSelectorControl;
    toJSON(data?: any): any;
}
export interface IPluginTypeSelectorControl extends ISetting {
    availableValues: AvailableValue[];
    selectedIndex?: number;
}
export declare class Resource implements IResource {
    source?: string | undefined;
    constructor(data?: IResource);
    init(_data?: any): void;
    static fromJS(data: any): Resource;
    toJSON(data?: any): any;
}
export interface IResource {
    source?: string | undefined;
}
export declare class FileDescriptor implements IFileDescriptor {
    numberOfChunks: number;
    fileSize: number;
    chunkSize: number;
    constructor(fileSize: number, chunkSize: number);
    init(_data?: any): void;
    static fromJS(data: any): FileDescriptor;
    toJSON(data?: any): any;
}
export interface IFileDescriptor {
    numberOfChunks: number;
    fileSize: number;
    chunkSize: number;
}
export declare class ComponentSettings extends ComponentSettingsBase implements IComponentSettings {
    settings?: Setting[] | undefined;
    constructor(data?: IComponentSettings);
    init(_data?: any): void;
    static fromJS(data: any): ComponentSettings;
    toJSON(data?: any): any;
}
export interface IComponentSettings extends IComponentSettingsBase {
    settings?: Setting[] | undefined;
}
export declare class ListItemType implements IListItemType {
    typeName?: string | undefined;
    typeDisplay?: DisplayAttribute | undefined;
    constructor(data?: IListItemType);
    init(_data?: any): void;
    static fromJS(data: any): ListItemType;
    toJSON(data?: any): any;
}
export interface IListItemType {
    typeName?: string | undefined;
    typeDisplay?: DisplayAttribute | undefined;
}
export declare class ProfileGroup implements IProfileGroup {
    profiles?: string[] | undefined;
    currentProfile?: string | undefined;
    groupName?: string | undefined;
    constructor(data?: IProfileGroup);
    init(_data?: any): void;
    static fromJS(data: any): ProfileGroup;
    toJSON(data?: any): any;
}
export interface IProfileGroup {
    profiles?: string[] | undefined;
    currentProfile?: string | undefined;
    groupName?: string | undefined;
}
export declare class RepositoryPackageReference implements IRepositoryPackageReference {
    name?: string | undefined;
    version?: string | undefined;
    repository?: string | undefined;
    path?: string | undefined;
    constructor(data?: IRepositoryPackageReference);
    init(_data?: any): void;
    static fromJS(data: any): RepositoryPackageReference;
    toJSON(data?: any): any;
}
export interface IRepositoryPackageReference {
    name?: string | undefined;
    version?: string | undefined;
    repository?: string | undefined;
    path?: string | undefined;
}
export declare class RepositoryPackageDefinition extends RepositoryPackageReference implements IRepositoryPackageDefinition {
    tags?: string[] | undefined;
    constructor(data?: IRepositoryPackageDefinition);
    init(_data?: any): void;
    static fromJS(data: any): RepositoryPackageDefinition;
    toJSON(data?: any): any;
}
export interface IRepositoryPackageDefinition extends IRepositoryPackageReference {
    tags?: string[] | undefined;
}
export declare class RepositorySettingsPackageDefinition extends RepositoryPackageDefinition implements IRepositorySettingsPackageDefinition {
    constructor(data?: IRepositorySettingsPackageDefinition);
    init(_data?: any): void;
    static fromJS(data: any): RepositorySettingsPackageDefinition;
    toJSON(data?: any): any;
}
export declare type IRepositorySettingsPackageDefinition = IRepositoryPackageDefinition;
export declare class SettingsTapPackage implements ISettingsTapPackage {
    name?: string | undefined;
    version?: string | undefined;
    tags?: string | undefined;
    group?: string | undefined;
    owner?: string | undefined;
    infoLink?: string | undefined;
    description?: string | undefined;
    files?: string[] | undefined;
    settingsTypes?: string[] | undefined;
    constructor(data?: ISettingsTapPackage);
    init(_data?: any): void;
    static fromJS(data: any): SettingsTapPackage;
    toJSON(data?: any): any;
}
export interface ISettingsTapPackage {
    name?: string | undefined;
    version?: string | undefined;
    tags?: string | undefined;
    group?: string | undefined;
    owner?: string | undefined;
    infoLink?: string | undefined;
    description?: string | undefined;
    files?: string[] | undefined;
    settingsTypes?: string[] | undefined;
}
export declare class SessionEventArgs implements ISessionEventArgs {
    sessionId?: string;
    protected _discriminator: string;
    constructor(data?: ISessionEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): SessionEventArgs;
    toJSON(data?: any): any;
}
export interface ISessionEventArgs {
    sessionId?: string;
}
export declare class SessionStartInitiated extends SessionEventArgs implements ISessionStartInitiated {
    constructor(data?: ISessionStartInitiated);
    init(_data?: any): void;
    static fromJS(data: any): SessionStartInitiated;
    toJSON(data?: any): any;
}
export declare type ISessionStartInitiated = ISessionEventArgs;
export declare class SessionStarted extends SessionEventArgs implements ISessionStarted {
    session?: Session | undefined;
    constructor(data?: ISessionStarted);
    init(_data?: any): void;
    static fromJS(data: any): SessionStarted;
    toJSON(data?: any): any;
}
export interface ISessionStarted extends ISessionEventArgs {
    session?: Session | undefined;
}
export declare class SessionStartFailed extends SessionEventArgs implements ISessionStartFailed {
    reason?: string | undefined;
    constructor(data?: ISessionStartFailed);
    init(_data?: any): void;
    static fromJS(data: any): SessionStartFailed;
    toJSON(data?: any): any;
}
export interface ISessionStartFailed extends ISessionEventArgs {
    reason?: string | undefined;
}
export declare class SessionShutdownInitiated extends SessionEventArgs implements ISessionShutdownInitiated {
    constructor(data?: ISessionShutdownInitiated);
    init(_data?: any): void;
    static fromJS(data: any): SessionShutdownInitiated;
    toJSON(data?: any): any;
}
export declare type ISessionShutdownInitiated = ISessionEventArgs;
export declare class SessionShutdown extends SessionEventArgs implements ISessionShutdown {
    constructor(data?: ISessionShutdown);
    init(_data?: any): void;
    static fromJS(data: any): SessionShutdown;
    toJSON(data?: any): any;
}
export declare type ISessionShutdown = ISessionEventArgs;
export declare class SessionShutdownFailed extends SessionEventArgs implements ISessionShutdownFailed {
    reason?: string | undefined;
    constructor(data?: ISessionShutdownFailed);
    init(_data?: any): void;
    static fromJS(data: any): SessionShutdownFailed;
    toJSON(data?: any): any;
}
export interface ISessionShutdownFailed extends ISessionEventArgs {
    reason?: string | undefined;
}
export declare class SessionInactivityLimitHit extends SessionEventArgs implements ISessionInactivityLimitHit {
    constructor(data?: ISessionInactivityLimitHit);
    init(_data?: any): void;
    static fromJS(data: any): SessionInactivityLimitHit;
    toJSON(data?: any): any;
}
export declare type ISessionInactivityLimitHit = ISessionEventArgs;
export declare class ImageEventArgs implements IImageEventArgs {
    imageId?: string | undefined;
    protected _discriminator: string;
    constructor(data?: IImageEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): ImageEventArgs;
    toJSON(data?: any): any;
}
export interface IImageEventArgs {
    imageId?: string | undefined;
}
export declare class ImageCreating extends ImageEventArgs implements IImageCreating {
    constructor(data?: IImageCreating);
    init(_data?: any): void;
    static fromJS(data: any): ImageCreating;
    toJSON(data?: any): any;
}
export declare type IImageCreating = IImageEventArgs;
export declare class ImageCreated extends ImageEventArgs implements IImageCreated {
    image?: Image | undefined;
    constructor(data?: IImageCreated);
    init(_data?: any): void;
    static fromJS(data: any): ImageCreated;
    toJSON(data?: any): any;
}
export interface IImageCreated extends IImageEventArgs {
    image?: Image | undefined;
}
export declare class ImageCreationFailed extends ImageEventArgs implements IImageCreationFailed {
    reason?: string | undefined;
    constructor(data?: IImageCreationFailed);
    init(_data?: any): void;
    static fromJS(data: any): ImageCreationFailed;
    toJSON(data?: any): any;
}
export interface IImageCreationFailed extends IImageEventArgs {
    reason?: string | undefined;
}
export interface FileParameter {
    file: any;
    fileName: string;
}
export interface FileResponse {
    data: Blob;
    status: number;
    fileName?: string;
    headers?: {
        [name: string]: any;
    };
}
export declare class ApiException extends Error {
    message: string;
    status: number;
    response: string;
    headers: {
        [key: string]: any;
    };
    result: any;
    constructor(message: string, status: number, response: string, headers: {
        [key: string]: any;
    }, result: any);
    protected isApiException: boolean;
    static isApiException(obj: any): obj is ApiException;
}
export declare class LogList implements ILogList {
    logs?: LogEntry[] | undefined;
    offset?: number;
    filteredCount?: number;
    totalCount?: {
        [key: string]: number;
    } | undefined;
    constructor(data?: ILogList);
    init(_data?: any): void;
    static fromJS(data: any): LogList;
    toJSON(data?: any): any;
}
export interface ILogList {
    logs?: LogEntry[] | undefined;
    offset?: number;
    filteredCount?: number;
    totalCount?: {
        [key: string]: number;
    } | undefined;
}
export declare class LogEntry implements ILogEntry {
    source?: string | undefined;
    timestamp?: number;
    message?: string | undefined;
    level?: number;
    durationNS?: number;
    constructor(data?: ILogEntry);
    init(_data?: any): void;
    static fromJS(data: any): LogEntry;
    toJSON(data?: any): any;
}
export interface ILogEntry {
    source?: string | undefined;
    timestamp?: number;
    message?: string | undefined;
    level?: number;
    durationNS?: number;
}
export declare class MissingLicenseResponse implements IMissingLicenseResponse {
    message?: string | undefined;
    constructor(data?: IMissingLicenseResponse);
    init(_data?: any): void;
    static fromJS(data: any): MissingLicenseResponse;
    toJSON(data?: any): any;
}
export interface IMissingLicenseResponse {
    message?: string | undefined;
}
export declare class RunStatus implements IRunStatus {
    sessionId?: string;
    verdict?: Verdict;
    testPlanRunId?: string | undefined;
    failedToStart?: boolean;
    executionState?: ExecutionState;
    executingSteps?: string[] | undefined;
    constructor(data?: IRunStatus);
    init(_data?: any): void;
    static fromJS(data: any): RunStatus;
    toJSON(data?: any): any;
}
export interface IRunStatus {
    sessionId?: string;
    verdict?: Verdict;
    testPlanRunId?: string | undefined;
    failedToStart?: boolean;
    executionState?: ExecutionState;
    executingSteps?: string[] | undefined;
}
/** Enumeration containing the verdict types used for Verdict and Verdict properties. */
export declare enum Verdict {
    NotSet = "NotSet",
    Pass = "Pass",
    Inconclusive = "Inconclusive",
    Fail = "Fail",
    Aborted = "Aborted",
    Error = "Error"
}
export declare enum ExecutionState {
    Idle = "Idle",
    Executing = "Executing",
    Breaking = "Breaking",
    Aborting = "Aborting",
    WaitingForUserInput = "WaitingForUserInput"
}
export declare class TestPlan implements ITestPlan {
    childTestSteps?: TestStep[] | undefined;
    settings?: Setting[] | undefined;
    isOpen?: boolean;
    propertiesToInclude?: string[] | undefined;
    id?: string;
    constructor(data?: ITestPlan);
    init(_data?: any): void;
    static fromJS(data: any): TestPlan;
    toJSON(data?: any): any;
}
export interface ITestPlan {
    childTestSteps?: TestStep[] | undefined;
    settings?: Setting[] | undefined;
    isOpen?: boolean;
    propertiesToInclude?: string[] | undefined;
    id?: string;
}
export declare class TestStep implements ITestStep {
    id?: string;
    childTestSteps?: TestStep[] | undefined;
    isChildTestStepsReadOnly?: boolean;
    isReadOnly?: boolean;
    settings?: Setting[] | undefined;
    typeName?: string | undefined;
    typeDisplay?: DisplayAttribute | undefined;
    name?: string | undefined;
    expandedName?: string | undefined;
    protected _discriminator: string;
    constructor(data?: ITestStep);
    init(_data?: any): void;
    static fromJS(data: any): TestStep;
    toJSON(data?: any): any;
}
export interface ITestStep {
    id?: string;
    childTestSteps?: TestStep[] | undefined;
    isChildTestStepsReadOnly?: boolean;
    isReadOnly?: boolean;
    settings?: Setting[] | undefined;
    typeName?: string | undefined;
    typeDisplay?: DisplayAttribute | undefined;
    name?: string | undefined;
    expandedName?: string | undefined;
}
export declare class TestStepType extends TestStep implements ITestStepType {
    availableChildrenTypes?: string[] | undefined;
    constructor(data?: ITestStepType);
    init(_data?: any): void;
    static fromJS(data: any): TestStepType;
    toJSON(data?: any): any;
}
export interface ITestStepType extends ITestStep {
    availableChildrenTypes?: string[] | undefined;
}
export declare class TestStepCopy extends TestStep implements ITestStepCopy {
    constructor(data?: ITestStepCopy);
    init(_data?: any): void;
    static fromJS(data: any): TestStepCopy;
    toJSON(data?: any): any;
}
export declare type ITestStepCopy = ITestStep;
export declare class TestStepValidationError implements ITestStepValidationError {
    stepId?: string | undefined;
    validationErrors?: ValidationError[] | undefined;
    constructor(data?: ITestStepValidationError);
    init(_data?: any): void;
    static fromJS(data: any): TestStepValidationError;
    toJSON(data?: any): any;
}
export interface ITestStepValidationError {
    stepId?: string | undefined;
    validationErrors?: ValidationError[] | undefined;
}
export declare class ValidationError implements IValidationError {
    propertyName?: string | undefined;
    error?: string | undefined;
    constructor(data?: IValidationError);
    init(_data?: any): void;
    static fromJS(data: any): ValidationError;
    toJSON(data?: any): any;
}
export interface IValidationError {
    propertyName?: string | undefined;
    error?: string | undefined;
}
export declare class CommonSettings implements ICommonSettings {
    step?: TestStep | undefined;
    stepIds?: string[] | undefined;
    constructor(data?: ICommonSettings);
    init(_data?: any): void;
    static fromJS(data: any): CommonSettings;
    toJSON(data?: any): any;
}
export interface ICommonSettings {
    step?: TestStep | undefined;
    stepIds?: string[] | undefined;
}
export declare class CommonContext implements ICommonContext {
    contextItems?: Setting[] | undefined;
    stepIds?: string[] | undefined;
    constructor(data?: ICommonContext);
    init(_data?: any): void;
    static fromJS(data: any): CommonContext;
    toJSON(data?: any): any;
}
export interface ICommonContext {
    contextItems?: Setting[] | undefined;
    stepIds?: string[] | undefined;
}
export declare class Interaction implements IInteraction {
    timeout?: string | undefined;
    title?: string | undefined;
    modal?: boolean | undefined;
    settings?: Setting[] | undefined;
    id?: string;
    constructor(data?: IInteraction);
    init(_data?: any): void;
    static fromJS(data: any): Interaction;
    toJSON(data?: any): any;
}
export interface IInteraction {
    timeout?: string | undefined;
    title?: string | undefined;
    modal?: boolean | undefined;
    settings?: Setting[] | undefined;
    id?: string;
}
export declare class InstalledFile implements IInstalledFile {
    relativePath?: string | undefined;
    tapPackage?: string | undefined;
    constructor(data?: IInstalledFile);
    init(_data?: any): void;
    static fromJS(data: any): InstalledFile;
    toJSON(data?: any): any;
}
export interface IInstalledFile {
    relativePath?: string | undefined;
    tapPackage?: string | undefined;
}
export declare class BreakPoints implements IBreakPoints {
    testSteps?: string[] | undefined;
    constructor(data?: IBreakPoints);
    init(_data?: any): void;
    static fromJS(data: any): BreakPoints;
    toJSON(data?: any): any;
}
export interface IBreakPoints {
    testSteps?: string[] | undefined;
}
export declare class Parameter implements IParameter {
    group?: string | undefined;
    name?: string | undefined;
    macroName?: string | undefined;
    parentLevel?: string | undefined;
    value?: string | undefined;
    constructor(data?: IParameter);
    init(_data?: any): void;
    static fromJS(data: any): Parameter;
    toJSON(data?: any): any;
}
export interface IParameter {
    group?: string | undefined;
    name?: string | undefined;
    macroName?: string | undefined;
    parentLevel?: string | undefined;
    value?: string | undefined;
}
export declare class WatchDog implements IWatchDog {
    inactiveSeconds?: number;
    terminationTimeout?: number;
    constructor(data?: IWatchDog);
    init(_data?: any): void;
    static fromJS(data: any): WatchDog;
    toJSON(data?: any): any;
}
export interface IWatchDog {
    inactiveSeconds?: number;
    terminationTimeout?: number;
}
export declare type IComponentSettingsIdentifier = IComponentSettingsBase;
export declare class TestRun implements ITestRun {
    status?: string | undefined;
    id?: string | undefined;
    verdict?: string | undefined;
    duration?: string | undefined;
    parameters?: Parameter[] | undefined;
    testStepRun?: TestStepRun | undefined;
    constructor(data?: ITestRun);
    init(_data?: any): void;
    static fromJS(data: any): TestRun;
    toJSON(data?: any): any;
}
export interface ITestRun {
    status?: string | undefined;
    id?: string | undefined;
    verdict?: string | undefined;
    duration?: string | undefined;
    parameters?: Parameter[] | undefined;
    testStepRun?: TestStepRun | undefined;
}
export declare class TestStepRun implements ITestStepRun {
    parentId?: string | undefined;
    testStepId?: string | undefined;
    testStepName?: string | undefined;
    constructor(data?: ITestStepRun);
    init(_data?: any): void;
    static fromJS(data: any): TestStepRun;
    toJSON(data?: any): any;
}
export interface ITestStepRun {
    parentId?: string | undefined;
    testStepId?: string | undefined;
    testStepName?: string | undefined;
}
export declare class LogEvent implements ILogEvent {
    source?: string | undefined;
    timestamp?: number;
    message?: string | undefined;
    eventType?: number;
    durationNS?: number;
    constructor(data?: ILogEvent);
    init(_data?: any): void;
    static fromJS(data: any): LogEvent;
    toJSON(data?: any): any;
}
export interface ILogEvent {
    source?: string | undefined;
    timestamp?: number;
    message?: string | undefined;
    eventType?: number;
    durationNS?: number;
}
export declare class Result implements IResult {
    stepRunID?: string | undefined;
    status?: string | undefined;
    name?: string | undefined;
    rows?: number;
    parent?: string | undefined;
    columns?: ResultColumn[] | undefined;
    constructor(data?: IResult);
    init(_data?: any): void;
    static fromJS(data: any): Result;
    toJSON(data?: any): any;
}
export interface IResult {
    stepRunID?: string | undefined;
    status?: string | undefined;
    name?: string | undefined;
    rows?: number;
    parent?: string | undefined;
    columns?: ResultColumn[] | undefined;
}
export declare class ResultColumn implements IResultColumn {
    name?: string | undefined;
    objectType?: string | undefined;
    data?: any[] | undefined;
    typeCode?: string | undefined;
    constructor(data?: IResultColumn);
    init(_data?: any): void;
    static fromJS(data: any): ResultColumn;
    toJSON(data?: any): any;
}
export interface IResultColumn {
    name?: string | undefined;
    objectType?: string | undefined;
    data?: any[] | undefined;
    typeCode?: string | undefined;
}
export declare enum SessionMetricKind {
    Poll = "Poll",
    Push = "Push",
    PushPoll = "PushPoll"
}
export declare enum SessionMetricType {
    Unknown = "Unknown",
    Double = "Double",
    Boolean = "Boolean",
    String = "String"
}
export declare enum MetricsPollRate {
    OneSecond = "OneSecond",
    TwoSeconds = "TwoSeconds",
    FiveSeconds = "FiveSeconds",
    TenSeconds = "TenSeconds",
    FifteenSeconds = "FifteenSeconds",
    OneMinute = "OneMinute",
    TwoMinutes = "TwoMinutes",
    FiveMinutes = "FiveMinutes",
    TenMinutes = "TenMinutes",
    FifteenMinutes = "FifteenMinutes",
    OneHour = "OneHour"
}
export declare class SessionMetricInfo implements ISessionMetricInfo {
    publish: boolean;
    kind: SessionMetricKind;
    type: SessionMetricType;
    attributes: object[];
    groupName: string;
    name: string;
    metricFullName: string;
    subjectPostfix: string;
    constructor(data?: ISessionMetricInfo);
    init(_data?: any): void;
    static fromJS(data: any): SessionMetricInfo;
    toJSON(data?: any): any;
}
export interface ISessionMetricInfo {
    publish: boolean;
    kind: SessionMetricKind;
    type: SessionMetricType;
    attributes: object[];
    groupName: string;
    name: string;
    metricFullName: string;
    subjectPostfix: string;
}
export declare class MetricsConfiguration implements IMetricsConfiguration {
    publishRate: MetricsPollRate;
    metrics: SessionMetricInfo[];
    constructor(data?: IMetricsConfiguration);
    init(_data?: any): void;
    static fromJS(data: any): MetricsConfiguration;
    toJSON(data?: any): any;
}
export interface IMetricsConfiguration {
    publishRate: MetricsPollRate;
    metrics: ISessionMetricInfo[];
}
export declare class MetricValue implements IMetricValue {
    time: number;
    value: boolean | number | string | object;
    constructor(data?: IMetricValue);
    init(_data?: any): void;
    static fromJS(data: any): MetricValue;
    toJSON(data?: any): any;
}
export interface IMetricValue {
    time: number;
    value: boolean | number | string | object;
}
export declare class SessionEvent implements ISessionEvent {
    eventType?: SessionEventType;
    sessionId?: string;
    protected _discriminator: string;
    constructor(data?: ISessionEvent);
    init(_data?: any): void;
    static fromJS(data: any): SessionEvent;
    toJSON(data?: any): any;
}
export interface ISessionEvent {
    eventType?: SessionEventType;
    sessionId?: string;
}
export declare enum SessionEventType {
    SessionStarting = "SessionStarting",
    SessionStarted = "SessionStarted",
    SessionStopping = "SessionStopping",
    SessionStopped = "SessionStopped",
    TestPlanChanged = "TestPlanChanged",
    TestPlanExecutionStateChanged = "TestPlanExecutionStateChanged",
    SettingsChanged = "SettingsChanged",
    TestStepChanged = "TestStepChanged",
    BreakEvent = "BreakEvent",
    UserInputRequested = "UserInputRequested",
    UserInputCompleted = "UserInputCompleted",
    SessionTimeoutHit = "SessionTimeoutHit",
    TestPlanSettingsChanged = "TestPlanSettingsChanged",
    TypeCacheInvalidated = "TypeCacheInvalidated",
    Heartbeat = "Heartbeat",
    MetricsConfigurationChanged = "MetricsConfigurationChanged"
}
export declare class SessionTimeoutEventArgs extends SessionEvent implements ISessionTimeoutEventArgs {
    constructor(data?: ISessionTimeoutEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): SessionTimeoutEventArgs;
    toJSON(data?: any): any;
}
export declare type ISessionTimeoutEventArgs = ISessionEvent;
export declare class StartingEventArgs extends SessionEvent implements IStartingEventArgs {
    constructor(data?: IStartingEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): StartingEventArgs;
    toJSON(data?: any): any;
}
export declare type IStartingEventArgs = ISessionEvent;
export declare class StartedEventArgs extends SessionEvent implements IStartedEventArgs {
    constructor(data?: IStartedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): StartedEventArgs;
    toJSON(data?: any): any;
}
export declare type IStartedEventArgs = ISessionEvent;
export declare class StoppingEventArgs extends SessionEvent implements IStoppingEventArgs {
    constructor(data?: IStoppingEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): StoppingEventArgs;
    toJSON(data?: any): any;
}
export declare type IStoppingEventArgs = ISessionEvent;
export declare class StoppedEventArgs extends SessionEvent implements IStoppedEventArgs {
    constructor(data?: IStoppedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): StoppedEventArgs;
    toJSON(data?: any): any;
}
export declare type IStoppedEventArgs = ISessionEvent;
export declare class TestPlanChangeEventArgs extends SessionEvent implements ITestPlanChangeEventArgs {
    constructor(data?: ITestPlanChangeEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanChangeEventArgs;
    toJSON(data?: any): any;
}
export declare type ITestPlanChangeEventArgs = ISessionEvent;
export declare class TestPlanExecutionStateChangedEventArgs extends SessionEvent implements ITestPlanExecutionStateChangedEventArgs {
    runStatus?: RunStatus | undefined;
    constructor(data?: ITestPlanExecutionStateChangedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanExecutionStateChangedEventArgs;
    toJSON(data?: any): any;
}
export interface ITestPlanExecutionStateChangedEventArgs extends ISessionEvent {
    runStatus?: RunStatus | undefined;
}
export declare class SettingsChangedEventArgs extends SessionEvent implements ISettingsChangedEventArgs {
    constructor(data?: ISettingsChangedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): SettingsChangedEventArgs;
    toJSON(data?: any): any;
}
export declare type ISettingsChangedEventArgs = ISessionEvent;
export declare class TestStepChangeEventArgs extends SessionEvent implements ITestStepChangeEventArgs {
    stepId?: string;
    constructor(data?: ITestStepChangeEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestStepChangeEventArgs;
    toJSON(data?: any): any;
}
export interface ITestStepChangeEventArgs extends ISessionEvent {
    stepId?: string;
}
export declare class BreakEventArgs extends SessionEvent implements IBreakEventArgs {
    stepId?: string;
    constructor(data?: IBreakEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): BreakEventArgs;
    toJSON(data?: any): any;
}
export interface IBreakEventArgs extends ISessionEvent {
    stepId?: string;
}
export declare class UserInputRequestEventArgs extends SessionEvent implements IUserInputRequestEventArgs {
    requestId?: string;
    constructor(data?: IUserInputRequestEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): UserInputRequestEventArgs;
    toJSON(data?: any): any;
}
export interface IUserInputRequestEventArgs extends ISessionEvent {
    requestId?: string;
}
export declare class UserInputRequestCompletedEventArgs extends SessionEvent implements IUserInputRequestCompletedEventArgs {
    requestId?: string;
    answered?: boolean;
    timeout?: boolean;
    constructor(data?: IUserInputRequestCompletedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): UserInputRequestCompletedEventArgs;
    toJSON(data?: any): any;
}
export interface IUserInputRequestCompletedEventArgs extends ISessionEvent {
    requestId?: string;
    answered?: boolean;
    timeout?: boolean;
}
export declare class TestPlanSettingsChangedEventArgs extends SessionEvent implements ITestPlanSettingsChangedEventArgs {
    constructor(data?: ITestPlanSettingsChangedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanSettingsChangedEventArgs;
    toJSON(data?: any): any;
}
export declare type ITestPlanSettingsChangedEventArgs = ISessionEvent;
export declare class HeartbeatEventArgs extends SessionEvent implements IHeartbeatEventArgs {
    constructor(data?: IHeartbeatEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): HeartbeatEventArgs;
    toJSON(data?: any): any;
}
export interface IHeartbeatEventArgs extends ISessionEvent {
    timestamp?: number;
    watchDog?: IWatchDog;
    state?: ExecutionState;
    testPlanRunID?: string;
}
export declare class MetricsConfigurationChangedEventArgs extends SessionEvent implements IMetricsConfigurationChangedEventArgs {
    constructor(data?: IMetricsConfigurationChangedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): MetricsConfigurationChangedEventArgs;
    toJSON(data?: any): any;
}
export interface IMetricsConfigurationChangedEventArgs extends ISessionEvent {
    metricsConfiguration?: IMetricsConfiguration;
}
export interface IOnTestPlanRun {
    status?: string;
    userId?: string;
}
export declare class OnTestPlanRun implements IOnTestPlanRun {
    status?: string;
    userId?: string;
    constructor(data?: IOnTestPlanRun);
    init(_data?: any): void;
    static fromJS(data: any): OnTestPlanRun;
    toJSON(data?: any): any;
}
export interface IOnTestStepRun {
    status?: string;
    stepId?: string;
    parentRunId?: string;
    verdict?: string;
    duration?: string;
}
export declare class OnTestStepRun implements IOnTestStepRun {
    status?: string;
    stepId?: string;
    parentRunId?: string;
    verdict?: string;
    duration?: string;
    constructor(data?: IOnTestStepRun);
    init(_data?: any): void;
    static fromJS(data: any): OnTestStepRun;
    toJSON(data?: any): any;
}
export interface ITestStepRunEvent {
    parent?: string;
    testStepId?: string;
    testStepName?: string;
    testStepTypeName?: string;
    id?: string;
    verdict?: number;
    startTime?: string;
    parameters?: Parameter[];
}
export declare class TestStepRunEvent implements ITestStepRunEvent {
    parent?: string;
    testStepId?: string;
    testStepName?: string;
    testStepTypeName?: string;
    id?: string;
    verdict?: number;
    startTime?: string;
    parameters?: Parameter[];
    protected _discriminator: string;
    constructor(data?: ITestStepRunEvent);
    init(_data?: any): void;
    static fromJS(data: any): TestStepRunEvent;
    toJSON(data?: any): any;
}
export declare type ITestStepRunStartEventArgs = ITestStepRunEvent;
export declare class TestStepRunStartEventArgs extends TestStepRunEvent implements ITestStepRunStartEventArgs {
    constructor(data?: ITestStepRunStartEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestStepRunStartEventArgs;
    toJSON(data?: any): any;
}
export declare type ITestStepRunCompletedEventArgs = ITestStepRunEvent;
export declare class TestStepRunCompletedEventArgs extends TestStepRunEvent implements ITestStepRunCompletedEventArgs {
    constructor(data?: ITestStepRunCompletedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestStepRunCompletedEventArgs;
    toJSON(data?: any): any;
}
export interface ITestPlanRunEvent {
    testPlanRunId?: number;
    testPlanRunGuid?: string;
    path?: string;
    name?: string;
    verdict?: string;
    startTime?: string;
    runner?: string;
    status?: string;
    isCampaign?: boolean;
    operator?: string;
}
export declare class TestPlanRunEvent implements ITestPlanRunEvent {
    testPlanRunId?: number;
    testPlanRunGuid?: string;
    path?: string;
    name?: string;
    verdict?: string;
    startTime?: string;
    runner?: string;
    status?: string;
    isCampaign?: boolean;
    operator?: string;
    protected _discriminator: string;
    constructor(data?: ITestPlanRunEvent);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanRunEvent;
    toJSON(data?: any): any;
}
export declare type ITestPlanRunStartEventArgs = ITestPlanRunEvent;
export declare class TestPlanRunStartEventArgs extends TestPlanRunEvent implements ITestPlanRunStartEventArgs {
    constructor(data?: ITestPlanRunStartEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanRunStartEventArgs;
    toJSON(data?: any): any;
}
export interface ITestPlanRunCompletedEventArgs extends ITestPlanRunEvent {
    durationInSeconds?: number;
}
export declare class TestPlanRunCompletedEventArgs extends TestPlanRunEvent implements ITestPlanRunCompletedEventArgs {
    durationInSeconds?: number;
    constructor(data?: ITestPlanRunCompletedEventArgs);
    init(_data?: any): void;
    static fromJS(data: any): TestPlanRunCompletedEventArgs;
    toJSON(data?: any): any;
}
export interface IRunnerEvent {
    runnerId?: string;
    type?: string;
}
export declare class RunnerEvent implements IRunnerEvent {
    runnerId?: string;
    type?: string;
    constructor(data?: IRunnerEvent);
    init(_data?: any): void;
    static fromJS(data: any): RunnerEvent;
    toJSON(data?: any): any;
}
export declare type IRunnerRegisteredEvent = IRunnerEvent;
export declare class RunnerRegisteredEvent extends RunnerEvent implements IRunnerRegisteredEvent {
    constructor(data?: IRunnerRegisteredEvent);
    init(_data?: any): void;
    static fromJS(data: any): RunnerRegisteredEvent;
    toJSON(data?: any): any;
}
export declare type IRunnerUpdatedEvent = IRunnerEvent;
export declare class RunnerUpdatedEvent extends RunnerEvent implements IRunnerUpdatedEvent {
    constructor(data?: IRunnerUpdatedEvent);
    init(_data?: any): void;
    static fromJS(data: any): RunnerUpdatedEvent;
    toJSON(data?: any): any;
}
export declare type IRunnerDeletedEvent = IRunnerEvent;
export declare class RunnerDeletedEvent extends RunnerEvent implements IRunnerDeletedEvent {
    constructor(data?: IRunnerDeletedEvent);
    init(_data?: any): void;
    static fromJS(data: any): RunnerDeletedEvent;
    toJSON(data?: any): any;
}
export declare class MetadataUpdatedEvent implements IMetadataUpdatedEvent {
    sessionId: string;
    metadata: {
        [key: string]: string;
    } | undefined;
    constructor(data?: IMetadataUpdatedEvent);
    init(_data?: any): void;
    static fromJS(data: any): MetadataUpdatedEvent;
    toJSON(data?: any): any;
}
export interface IMetadataUpdatedEvent {
    sessionId: string;
    metadata: {
        [key: string]: string;
    } | undefined;
}
export interface IAssetUpdatedEvent extends IRunnerEvent {
    assets?: string[] | undefined;
}
export declare class AssetUpdatedEvent extends RunnerEvent implements IAssetUpdatedEvent {
    assets?: string[] | undefined;
    protected _discriminator: string;
    constructor(data?: IAssetUpdatedEvent);
    init(_data?: any): void;
    static fromJS(data: any): AssetUpdatedEvent;
    toJSON(data?: any): any;
}
