import { JSONCodec, StringCodec } from 'nats.ws';
export const numberCodec = NumberCodec();
export const booleanCodec = BooleanCodec();
export const stringCodec = StringCodec();
export const jsonCodec = JSONCodec();
export function NumberCodec() {
    return {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        encode(d) {
            throw new Error('not implemented');
        },
        decode(a) {
            const dataView = new DataView(a.buffer);
            return dataView.getFloat64(a.byteOffset, true); // BitConverter.ToDouble in C# is little-endian
        },
    };
}
export function BooleanCodec() {
    return {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        encode(d) {
            throw new Error('not implemented');
        },
        decode(a) {
            return a[0] === 1;
        },
    };
}
